'FreeBasic
'Train

Const     Version = "V 0.34"
Const FileVersion = "0.34"

' Implement bitmap as background map file

' ToDo
'
' init-script support
' load bitmaps and place maps (done)
'
' load and save functions
' (tracks, items, ...)
'
' Location markers
' compass show direction to selected location
'
'
' tutorial missions
' change view and zoom
' navigate (move world with cursor/mouse)
' control train speed
' place new train
' place items, change items, debug view
'
'
' Item load / save
'
'
' Item designer
'


'Coordinates are stored in integers (32 bit)
'Resolution is 1 mm

' German - English
' Weiche = Turnout
' Gerade = Straight track
' Waggon = car
' Nebengleis = Passing siding
' Passagierwaggon = cab car
' Lokomotive - ?
' 

' Just for future extensions.
' Order of drawing:
' Water
' Floor, Streets
' Tracks
' People
' Cars
' Trains
' Buildings
' Trees
' Planes
' Clouds
' 

rem Option Explicit

#include "GFXPrint.bas"
#include "loopedit.bas"

'################################################
'## Definitions and constants
'################################################


'convert world to pixel
#define xcoor(x) (v.Offx+((x)/v.Scale))
#define ycoor(y) (v.Offy+((y)/v.Scale))

'convert pixel to world
#define p2wx(x) (((x)-v.Offx)*v.Scale)
#define p2wy(y) (((y)-v.Offy)*v.Scale)

'convert pixel to world, window 2
#define p2wxw2(x) (((x)-view2.Offx)*view2.Scale)
#define p2wyw2(y) (((y)-view2.Offy)*view2.Scale)

'define data type to save coordinates
#define xyz Integer
'#define xyz Single

#define mapon 1
#define landmapon 1


Const CCamSteps=10            '1..100 number of frames for slide animation
                              'don't set to zero (div by zero error)
Const CScanCam=200            'change cam view after # frames
Const CScanCamActive=1        '0=off, 1=on

Const CZoomMinLevel=10        '1 pixel = 10mm
Const CZoomMaxLevel=100000    '1 pixel = 100m
Const CGroundColor = &H106010 'Default Ground Color
Const CTextColor = &HFFFFFF   'Default Text Color
Const CMsgBoxColor = &H303030 'Message Box Background Color

Const CDataPath="./data/"
Const CInitFile="trainini.txt"    ' prog configuration
Const CDataFile="traindat.txt"    ' tracks, trains / world
Const CModelFile="trainmod.txt"   ' vector models / items
Const CLogFile="trainlog.txt"     ' vector models / items
Const MessageTimer=100
Const CMapPerformance=20       ' max # msec to draw bitmaps

Const WinXMax=640, WinYMax=480 ' WinX=640, WinY=480
Const m=1000  '1 Meter
Const PI AS Single = 4*Atn(1.0)
Const MaxItems=1000            ' vector models placed in world
Const MaxModels=100             'vector model (building, train, ...)
Const MaxBmp=1000
Const MaxTrains=1000
Const MaxTracks=1000
Const MaxTurnouts=1000
Const WorldX=20, WorldY=15  'World size in km
Const MapRes=10
Const MinAngle=512/64       'smallest angle, 
                            'need MinAngle turns for a track circle

# define visborder

'Const visborderx=-winx/10
'Const visbordery=-winy/10
''Const visborderx=winx/10
''Const visbordery=winy/10

Const click=4       'mouse click or drag
                    'If g.Mousehold>g.Fps/click

Const trackwidth=2.0/2

'Keyboard control
Const K_help=Chr$(255)+Chr$(59)              'F1
Const K_helpdisp=Chr$(255)+Chr$(60)          'F2
Const K_ohd=Chr$(255)+Chr$(61)               'F3
Const K_LoopEditFlag="(i)"
Const K_LoopEditStart="i"
Const K_LoopEditEnd="(i)q"
Const K_edittrack="e"
Const K_edittrackFlag="(e)"
Const K_edittrackOpen="(e)o"    ' has no effect
Const K_edittrackClose="(e)c"   ' has no effect
Const K_edittrackEnd="(e)e"
Const K_edittrackInstallTurnout="(e)u"
Const K_edittrackNext="(e)+"
Const K_edittrackPrev="(e)-"
Const K_edittrackSelect="(e) "
Const K_edittrackSignal="(e)i"
Const K_edittrackForward="(e)f"
Const K_edittrackStation="(e)s"
Const K_edittrackLeft="(e)l"
Const K_edittrackRight="(e)r"
Const K_edittrackSharpLeft="(e)L"
Const K_edittrackSharpRight="(e)R"
Const K_edittrackEndtrack="(e)E"
Const K_edittrackInsert="(e)"+Chr$(255)+"R" 'Insert
Const K_edittrackDelete="(e)"+Chr$(255)+"S" 'Delete
Const K_edittrackDefaultlength="(e)d"
Const K_SwitchTurnout="u"
Const K_SwitchTurnoutReverse="U"
Const K_NewItem="n"
Const K_Plus="+"
Const K_Minus="-"
Const K_Insert=Chr$(255)+"R"                'Insert
Const K_Delete=Chr$(255)+"S"                'Delete
Const K_rotateleft="<"
Const K_rotateright=">"
Const K_zoomin=Chr$(255)+"I"                'Pg-Up
Const K_zoomout=Chr$(255)+"Q"               'Pg-Down
Const K_grid="g"
Const K_map="M"
Const K_landmap="m"
Const K_debug="d"
Const K_file="F"
Const K_loadfile="f"
Const K_SelectCamera="1234567890"
Const K_CtrlNext=Chr$(9)                    'Tab
Const K_CtrlPrev=Chr$(255)+Chr$(15)+Chr$(9) 'Shift+Tab
Const K_WatchTrain="w"
Const K_CenterTrack="t"
Const K_Stop="s"
Const K_ManualCtrl=" "
Const K_BeamTrack="b"
Const K_TrainAutopilot="a"
Const K_AccRev=","
Const K_AccFwd="."
Const K_AccRevMore="k"
Const K_AccFwdMore="l"
Const K_AccAllRev=";"
Const K_AccAllFwd=":"
Const K_AccAllRevMore="K"
Const K_AccAllFwdMore="L"
Const K_CamUp=Chr$(255)+"H"                 'Cursor up
Const K_CamDn=Chr$(255)+"P"                 'Cursor down
Const K_CamLt=Chr$(255)+"K"                 'Cursor left
Const K_CamRt=Chr$(255)+"M"                 'Cursor right
Const K_Quit=Chr$(27)                       'Esc
Const K_Quit2=Chr$(255)+"k"                 'Alt+F4

Const invisiblecolor = &HFF00FF

'Train control flags
Const none=&H0000
Const auto=&H0001
Const brake=&H0002
Const slow=&H0004
Const crash=&H8000


'DrawItem constants for CoorScale
Const ScaleVehicle=10
Const ScaleBuilding=4

Const Items=1
Const Buildings=1
Const Vegetation=3
Const Locomotives=4
Const Grounds=7 'not used
Const EndItems=6




'################################################
'## Types
'################################################


Type p3
  x As Integer
  y As Integer
  z As Integer
End Type

Type rect
  As Integer minx,miny,maxx,maxy
End Type

'Type signal
'  As Short SignalType, SignalValue
'End Type

Type PTrack As TTrack Ptr
Type PTurnout As TTurnout Ptr
Type PTrackBase As TTrackBase Ptr
Type PTrain As TTrain Ptr
Type PMapR As TMapR Ptr
Type PItem As TItem Ptr
Type PModel As TModel Ptr
Type PBmp As TBmp Ptr
Type PBmp1023 As TBmp1023 Ptr


Type TTrack
  As PTrackBase mytrack 'Where am I driving on?
  As PTrack pf, pr      'forward/reverse (drive train)
  As PTrack pn          'next track (draw, load, save)
  As xyz x, y, z        'position of track start
  As Integer length     'position of track start
  As Integer TNum       'Info: track segment counter
  As String tname       'Info: which type of track (build string)
  As Integer angle      'Info: angle of track segment
  As Integer sin0, cos0 'Info: position offset of left/right track line
  As Integer distance   'Info: distance from start
  As String SigF, SigR  'Info: signal for train control, autopilot
  As PTurnout turn      'Turnout pointer
End Type

Type TTurnout
'  As String tname
  As p3 SwitchCoor      'switch coordinates, relative to pr1
  As PTrack pr, pf      'actual pointer to track
  As PTrack pr1, pf1    'pointer to track 1
  As PTrack pr2, pf2    'pointer to track 2
  As Integer turn       '1=forward, 2=turned
End Type

Type TTrackBase
  As PTrack start, last 'link pointer to start/last segment
  As String build       'Track build string
  As xyz x, y, z        'position of track start
  As xyz xa, ya, za     'actual position of track end
  As Integer angle,anga 'angle of track start
  As Integer length     'track length
  As String tname       'Track name
  As rect dimension
End Type

Type TTrain
  As PTrack tr          'tr=actual track segment
  As Integer ps         'position on track segment
  As Integer sp         'speed
  As Integer x,y,z      'coordinates
  As Integer waggons, pic
  As Integer control    '0=none, 1=brake
  As Integer AutoSpeed  'if AutoSpeed<>0: change train speed
End Type

Type TMapR
  As Integer x1,y1,z1 'coordinates
  As Integer x2,y2,z2 'coordinates
  As Integer Color
  As PMapR pnext
End Type

Type TItem
  As p3 a,b   'coordinates
  As Integer build
  As Integer Col, ScaleType
End Type

Type TModel
  As String mName
  As String mBuild      'vector graphics commands
End Type

Type TBmp
  As Integer x, y       'coordinates
  As Integer scale      '1230 -> pixel size is 1.23 meter
  As Integer ZoomMin    'zoom range for display
  As Integer ZoomMax    'zoom range for display
  As Integer BmpIndex   'number ob BMP1023-Array
  As String mapname     'symbolic name
End Type

Type TBmp1023
  As String filename    'file name
  As Integer w, h       'size
  As Integer data(1023,1023)
End Type

Type TWorldStatus
 'The world
 As PMapR Map
 As PItem Items(MaxItems)
 As PBmp MapHdr(MaxBmp)
 As PBmp1023 MapData(MaxBmp)
 As PTrackBase Start(MaxTracks)
 As PModel Model(MaxModels)
 As PTurnout Turnouts(MaxTurnouts)
 As PTrain Train(MaxTrains)
End Type

Type TWorldView
 'View
 As Integer WinX,WinY,PosX,PosY     'Window size and position
 As Integer VisBorderX,VisBorderY   'Location offset for tracks etc.

 As Integer Scale                   'World view position and scale
 As Integer Cam

' As Integer OldCam
 As Integer OldCamX
 As Integer OldCamY
 As Integer OldCamScale
 As Integer CamSlide

 As Integer mapactive
 As Integer landmapactive
 As Integer Debug
 As Integer GridOn
 As Integer Offx,Offy               '"
End Type

Type TGlobals
 'The user interface
 As String buildtrk 'definition of track building characters
 As String ks
 As Integer ofx,ofy                 'Location offset for tracks etc.
 As PTrack EditTrkPtr, EditTrkPtrA
 As PTrackBase EditTrkBasePtr
 As Integer mousex, mousey, mousewh, mousebt
 As Integer mousexs, mouseys, mousewhs, mousebts, mousehold
 As Integer ItemSel, trksel, EditTrk, ctrl
 As String ItemSelName
 As Integer Drag
 As Double now, frame, Fps, Fps0
 As Double AvgTime, AvgMax, ThisTime, LastTime
 As Integer FpsLow, SkipFrame, PrintFrame
End Type


'################################################
'## Variables
'################################################


'Graphics screen pointer
'Dim As Byte p1=0,p2=1
Dim Shared As Any Ptr win480, win160

'The world
Dim Shared As TWorldStatus w
Dim Shared As TWorldView v,View1,View2,View3,View4
Dim Shared As TGlobals g

'Dim As PWorldStatus pw=@w

'Global stuff
Dim Shared As String ks   'user input from keyboard
Dim As PMapR Map1         'temporary pointer (follow chain)
Dim As Integer i, j       'temporary variables
Dim As Integer col        'temporary variable
Dim As String s           'temporary string
Dim As PTrain waggon      'temporary pointer (display train cars)
Dim As Integer wagx, wagy 'temporary coordinates (display train cars)
Dim As Integer ofx, ofy   'Location offset for tracks etc.

Dim Shared As Integer helpman=1           'display manual on/off
Dim Shared As Integer OhdFps              'OHD on/off
Dim Shared As Integer MouseWindow         'window area under mouse cursor

Dim Shared As String DataPath             'ini-file, bitmaps ...
Dim Shared As Integer MapPerformance      'time to draw background bitmaps (msec)

Dim Shared As Integer ZoomMinLevel=CZoomMinLevel
Dim Shared As Integer ZoomMaxLevel=CZoomMaxLevel
Dim Shared As Integer GroundColor=CGroundColor
Dim Shared As Integer ScanCam

'Track editor
Dim Shared As String ted_dir   'direction lLfRr
Dim Shared As String ted_len   'track length 0..9



'''''''''''''''''''''''''''''''''''''''''''''''''''''
Dim Shared beamer As Integer

Randomize

'Build a track
'A track will be built from a string
'Every letter adds a new segment to the track
'
' f[l] = forward track
' l[l] = left turn track (use 8 times for 180 turn)
' L[l] = sharp left turn (use 16 times for 180 turn)
' r[l] = right turn
' R[l] = sharp right turn
' s[l] = station, 5 times as long as a track
'        entering a station will cause the train to brake
'        until it stops.
' *[n] = place last item n times
'
' [l] = 0..9
' [n] = 2..99
'
' Default length of a new segment is 25 meter
' Lenghth can be changed by addin a single digit behind the letter
' length can be set from 0 (5 m) to 9 (50 m)
'
' Example 1:
' f  = forward 25 meter
' f0 = forward 5 meter
' f1 = forward 10 meter
' l2 = left 15 meter
' l3 = left 20 meter
' R5 = sharp right 30 meter
' r9 = right 50 meter
'
' Example 2: Build track as a "0"
' start with "LLLL" for a 90 Left turn, built with 25 m elements
' add "LLLL9" for a next 90 Left turn with a long 50 m end
' add "LLLL LLLL9" to complete the track
'
' Spaces and line breaks are allowed in the string,
' they will be ignored.


g.BuildTrk="flrLRsec"
'ts0="L0*16e"
'ts1="L2*7L9L2*7L9e"
'ts2="f*4 r*16 f*4 r*16 e"
'ts3="f*8 f5 l*24 f*9 f5 r*24 f e"
'ts4="ff s f*12 l*8 ffff l*8 s l*8 f*10 r*8 ff r*8 ff rrrr ff rrrr ff r*8 fff*10 r*8 s f r*8 ffff r*6 f4 rr e"
'ts5="fff*10 l2*8 ffff l1*8 ffff l0*8 f*14 R0*4 f9f9fff r*8 ff rrrr ff rrrr ff r*8 fff*10 r*8 f*6 r*8 ffff f3 r*8 f3f3 e"
'ts6="f*18 l*8 ffff l*8 ffff l*8 f*10 r*8 ff r*8 ff rrrr ff rrrr ff r*8 fff*10 r*8 f*6 r*8 ffff r*6 f4 rr e"
'ts7="l*16 s l*16 f*5 e" '0
'ts8="f*66 r*8 f*66 r*8 f*66 r*8 f*66 r*8 e"


'test loop editor
Dim Shared As String edits


'################################################
'## logfile
'################################################


Sub LogFile(s As String)
  Dim As Integer f, r
  
  f=FreeFile
  If 0=Open (CDataPath+CLogFile For Append As #f) Then
    Print #f, s
    Close #f
  EndIf
  
End Sub


Sub LogFileNoBr(s As String)
  Dim As Integer f, r
  
  f=FreeFile
  If 0=Open (CDataPath+CLogFile For Append As #f) Then
    Print #f, s;
    Close #f
  EndIf
  
End Sub



'################################################
'## Little helper (1)
'################################################


Dim Shared As Integer MsgCnt
Dim Shared As String NewMessage
Sub message(msg As String)
  MsgCnt=MessageTimer
  NewMessage=msg
End Sub


'################################################
'## Functions / Subs (Graphics)
'################################################


'' A function that creates an image buffer with the same 
'' dimensions as a BMP image, and loads a file into it.

Const NULL As Any Ptr = 0

Function bmp_load( ByRef filename As String ) As Any Ptr
    Dim As Integer filenum, bmpwidth, bmpheight
    Dim As Any Ptr img
    '' open BMP file
    filenum = FreeFile()
    If Open( filename For Binary Access Read As #filenum ) <> 0 Then Return NULL
        '' retrieve BMP dimensions
        Get #filenum, 19, bmpwidth
        Get #filenum, 23, bmpheight
    Close #filenum
    '' create image with BMP dimensions
    img = ImageCreate( bmpwidth, Abs(bmpheight) )
    If img = NULL Then Return NULL
    '' load BMP file into image buffer
    If BLoad( filename, img ) <> 0 Then ImageDestroy( img ): Return NULL
    Return img
End Function


Function visible(x As Integer,y As Integer) As Integer
  If (xcoor(x)>=(0-v.VisBorderX)) And (xcoor(x)<(v.WinX+v.VisBorderX)) _
  And (ycoor(y)>=(0-v.VisBorderY)) And (ycoor(y)<(v.WinY+v.VisBorderY)) Then
    Return 1
  Else
    Return 0
  EndIf
End Function


Function overlap(a1 As Integer,b1 As Integer,a2 As Integer,b2 As Integer) As Integer
  Dim As Integer ol
  ol=0
  'check if length(a1,b1) > length(a2,b2)
  If (b1-a1)>=(b2-a2) Then
    If (a2>a1) And (a2<b1) _
    Or (b2>a1) And (b2<b1) Then ol=1
  Else
    If (a1>a2) And (a1<b2) _
    Or (b1>a2) And (b1<b2) Then ol=1
  EndIf
  Return ol
End Function


Function visrect(x1 As Integer, y1 As Integer, x2 As Integer, y2 As Integer) As Integer
  If overlap(p2wx(0), p2wx(v.WinX), x1, x2) _
  And overlap(p2wy(0), p2wy(v.WinY), y1, y2) Then
    Return 1
  Else
    Return 0
  EndIf
End Function


Function VisRectBorder(x1 As Integer, y1 As Integer, x2 As Integer, y2 As Integer) As Integer
  If overlap(p2wx(0-v.VisBorderX), p2wx(v.WinX+v.VisBorderX), x1, x2) _
  And overlap(p2wy(0-v.VisBorderY), p2wy(v.WinY+v.VisBorderY), y1, y2) Then
    Return 1
  Else
    Return 0
  EndIf
End Function


Function VisRectItem(x1 As Integer, y1 As Integer, x2 As Integer, y2 As Integer) As Integer
  'check distance (x^2+y^2 < Distance^2)
  Dim As Integer d
  If (((xcoor(x1)-v.WinX/2)^2 _
      +(ycoor(y1)-v.WinY/2)^2)) _
      <(v.WinX*v.WinX+v.WinY*v.WinY) Then
    Return 1
  Else
    If (((xcoor(x2)-v.WinX/2)^2 _
        +(ycoor(y2)-v.WinY/2)^2)) _
        <(v.WinX*v.WinX+v.WinY*v.WinY) Then
      Return 1
    Else
      Return 0
    EndIf
  EndIf
End Function


Sub ScreenCenter(x As Integer, y As Integer)
  v.Offx=v.winx/2-x/v.Scale
  v.Offy=v.winy/2-y/v.Scale
End Sub


Function SCX As Integer
  'Screen Center GetX
  Return p2wx(v.WinX/2)
End Function


Function SCY As Integer
  'Screen Center GetX
  Return p2wy(v.WinY/2)
End Function


Sub TriDraw(a1 As p3, b1 As p3, c1 As p3, col As Integer, dwin As Any ptr)
  Dim As p3 a, b, c, t
  Dim As Integer y, dy, xa, xb, L1, D1, L2, D2
  
  a=a1: b=b1: c=c1
  If a.y>b.y Then: t=b: b=a: a=t: EndIf
  If a.y>c.y Then: t=c: c=a: a=t: EndIf
  If b.y>c.y Then: t=c: c=b: b=t: EndIf
  
  dy=c.y-a.y
  For y=0 To dy
    If y=(b.y-a.y) Then
      xa=b.x
    Else
      If y<(b.y-a.y) Then
        L1=y
        D1=b.y-a.y
        xa=(b.x*L1+a.x*(D1-L1))/D1
      Else
        L1=y-b.y+a.y
        D1=c.y-b.y
        xa=(c.x*L1+b.x*(D1-L1))/D1
      EndIf
    EndIf
    L2=y
    D2=c.y-a.y
    If d2=0 Then
      xb=c.x
    Else
      xb=(c.x*L2+a.x*(D2-L2))/D2
    EndIf
    Line dwin,(xa,y+a.y)-(xb,y+a.y),col
  Next
End Sub


Sub drawgrid(gx1 As Integer, gy1 As Integer, gx2 As Integer, gy2 As Integer, dots As Integer,dwin As Any Ptr)
  Dim As Integer x, y, x1, y1, x2, y2
  
  If v.Scale<=100 Then
    For x=0 To v.WinX
      If (p2wx(x) Mod m)<(v.Scale) Then
        For y=0 To v.WinY
          If (p2wy(y) Mod m)<(v.Scale) Then
            PSet dwin,(x,y),&H00FFFF
          EndIf
        Next
      EndIf
    Next
  EndIf
  
  If (v.Scale<1000) Then
    For x=0 To v.WinX
      If (p2wx(x) Mod (m*10))<(v.Scale) Then
        For y=0 To v.WinY
          If (p2wy(y) Mod (m*10))<(v.Scale) Then
            PSet dwin,(x,y),&H8080FF
            If v.Scale<250 Then
              Line dwin,(x-1,y-1)-(x+1,y+1),&H80c0FF,B
            EndIf
          EndIf
        Next
      EndIf
    Next
  EndIf
  
  If (v.Scale<10000) Then
    For x=0 To v.WinX
      If (p2wx(x) Mod (m*100))<(v.Scale) Then
        For y=0 To v.WinY
          If (p2wy(y) Mod (m*100))<(v.Scale) Then
            PSet dwin,(x,y),&Hffff80
          EndIf
        Next
      EndIf
    Next
  EndIf
  
  If (v.Scale<100000) Then
    For x=0 To v.WinX
      If (p2wx(x) Mod (m*1000))<(v.Scale) Then
        For y=0 To v.WinY
          If (p2wy(y) Mod (m*1000))<(v.Scale) Then
            Line dwin,(x-1,y-1)-(x+1,y+1),&H808080,BF
          EndIf
        Next
      EndIf
    Next
  EndIf
  
  If (v.Scale<1000000) Then
    For x=0 To v.WinX
      If (p2wx(x) Mod (m*10000))<(v.Scale) Then
        For y=0 To v.WinY
          If (p2wy(y) Mod (m*10000))<(v.Scale) Then
            Line dwin,(x-1,y-1)-(x+1,y+1),&HFFFF80,BF
          EndIf
        Next
      EndIf
    Next
  EndIf
  
End Sub


Sub DrawSubTrackHighlighted(T As PTrack, col As Integer,dwin As Any ptr)
  If T->pf<>0 Then
    Line dwin,(xcoor(T->x),ycoor(T->y))-(xcoor(T->pf->x),ycoor(T->pf->y)), col
  EndIf
  Circle dwin,(xcoor(T->x),ycoor(T->y)),3,&H00ff00,,,,F
End Sub


Sub DrawSubTrack(T As PTrack, col As Integer,dwin As Any ptr)
  If T->pf<>0 Then
    Line dwin,(xcoor(T->x),ycoor(T->y))-(xcoor(T->pf->x),ycoor(T->pf->y)), col
  EndIf
End Sub


Sub DrawTrack(Track As PTrackBase, selected As Integer, dwin As Any ptr)
  Dim As PTrack T
  Dim As Integer col
  Dim As Integer x1,y1,x2,y2,a, a1, a2
  'Draw track base coordinates
  If selected Then
    Circle dwin,(xcoor(Track->x),ycoor(Track->y)),3+3*m/v.Scale,&H5050ff,,,,F
  Else
    Circle dwin,(xcoor(Track->x),ycoor(Track->y)),3+3*m/v.Scale,&H505060,,,,F
  EndIf
  Circle dwin,(xcoor(Track->x),ycoor(Track->y)),3+3*m/v.Scale,&H707090
  'Draw track
  If (m/v.Scale)>0.5 Then
    'show more details when zoomed in
    T=Track->start
    Do
      'draw left/right rails
      'choose color
      col=&H606080
      If T->tname="s" Then col=&H60c0ff   'Highlight Track "s" = Station
      If T->turn<>0 Then   col=&H8080ff   'Highlight Turnout
      If selected Then col=col+&H2f3f00
      If T->SigF<>"" Then col=&H60c0ff    'Highlight Track with Signal
      If T->SigR<>"" Then col=&H60c0ff    'Highlight Track with Signal
      
      If T->pf>0 Then
        x1=T->x
        y1=T->y
        x2=T->pf->x
        y2=T->pf->y
        Line dwin,(xcoor(x1+T->Sin0), ycoor(y1-T->Cos0)) _
           -(xcoor(x2+T->pf->Sin0), ycoor(y2-T->pf->Cos0)),col
        Line dwin,(xcoor(x1-T->Sin0), ycoor(y1+T->Cos0)) _
           -(xcoor(x2-T->pf->Sin0), ycoor(y2+T->pf->Cos0)),col
      EndIf
      T=T->pn
    Loop Until T=0
  Else
    'show less details when zoomed out
    T=Track->start
    Do
      'choose color
      col=&H606080
      If T->tname="s" Then col=&H60c0ff
      If T->turn<>0 Then   col=&H8080ff
      If selected Then col=col+&H2f3f00
      If T->pf<>0 Then
        Line dwin,(xcoor(T->x), ycoor(T->y))-(xcoor(T->pf->x), ycoor(T->pf->y)), col
      EndIf
      T=T->pn
    Loop Until T=0
  EndIf
  'Circles between track segments
  If (m/v.Scale)>1 Then
    'show more details when zoomed in
    T=Track->start
    Do
      Circle dwin,(xcoor(T->x),ycoor(T->y)),0.5*m/v.Scale,&H00ff00
      T=T->pn
    Loop Until T=0
  EndIf
End Sub


'################################################
'## Functions / Subs (Graphics - Objects/Items)
'################################################


Function iVehicle As String
  Return "v"
End Function


Function iAddZoomIn(zoom As Integer) As String
  Return "Z"+Chr(zoom)
End Function


Function iAddZoomOut(zoom As Integer) As String
  Return "z"+Chr(zoom)
End Function


Function iAddColor(col As Integer) As String
  Dim s As String
  'Color
  s="O"+Chr(col Shr 16 And &Hff) _
    +Chr(col Shr 8 And &Hff) _
    +Chr(col And &Hff)

  Return s
End Function


Function iAddLine(x1 As Integer, y1 As Integer, x2 As Integer, y2 As Integer) As String
  Dim s As String
  'Line
  s="L"+Chr(x1+128)+Chr(y1+128)+Chr(x2+128)+Chr(y2+128)
  Return s
End Function


Function iAddFTri(x1 As Integer, y1 As Integer, x2 As Integer, y2 As Integer, x3 As Integer, y3 As Integer) As String
  Dim s As String
  'Filled Triangle
  s="T"+Chr(x1+128)+Chr(y1+128) _
   +Chr(x2+128)+Chr(y2+128) _
   +Chr(x3+128)+Chr(y3+128)
  Return s
End Function


Function iAddBox(x1 As Integer, y1 As Integer, x2 As Integer, y2 As Integer) As String
  Dim s As String
  'Box
  s="L"+Chr(x1+128)+Chr(y1+128)+Chr(x1+128)+Chr(y2+128) _
   +"L"+Chr(x1+128)+Chr(y2+128)+Chr(x2+128)+Chr(y2+128) _
   +"L"+Chr(x2+128)+Chr(y2+128)+Chr(x2+128)+Chr(y1+128) _
   +"L"+Chr(x2+128)+Chr(y1+128)+Chr(x1+128)+Chr(y1+128)
  Return s
End Function


Function iAddFBox(x1 As Integer, y1 As Integer, x2 As Integer, y2 As Integer) As String
  Dim s As String
  'Filled Box
  s="T"+Chr(x1+128)+Chr(y1+128) _
   +Chr(x2+128)+Chr(y1+128) _
   +Chr(x1+128)+Chr(y2+128) _
   +"T"+Chr(x1+128)+Chr(y2+128) _
   +Chr(x2+128)+Chr(y1+128) _
   +Chr(x2+128)+Chr(y2+128)
  Return s
End Function


Function iAddCircle(x As Integer, y As Integer, r As Integer) As String
  Return "C"+Chr(x+128)+Chr(y+128)+Chr(r) 's
End Function


Function iAddFCircle(x As Integer, y As Integer, r As Integer) As String
  Return "D"+Chr(x+128)+Chr(y+128)+Chr(r) 's
End Function


Sub DrawItem(x1 As Integer, y1 As Integer, x2 As Integer, y2 As Integer, model As Integer, col As Integer, dwin As Any Ptr)
  Dim As longInt tx0,ty0,tx1,ty1,tx2,ty2
  Dim As Integer rx0,ry0,rx1,ry1,rx2,ry2
  Dim As Integer i, co, ucol, CoorScale=ScaleBuilding
  Dim As longint d
  Dim As p3 a, b, c
  If VisRectItem(x1, y1, x2, y2) Then
    tx0=x1
    ty0=y1
    tx1=(x2-x1)
    ty1=(y2-y1)
    tx2=(y2-y1)
    ty2=-(x2-x1)
    i=0
    Do While i<Len(w.model(model)->mBuild)
      'Commands with shortest parameter list first!
      If w.model(model)->mBuild[i]=Asc("v") Then
        'Vehicle coordinate scale
        CoorScale=ScaleVehicle
      EndIf
      If w.model(model)->mBuild[i]=Asc("Z") Then
        'ZoomIn
        i+=1: rx0=w.model(model)->mBuild[i]
        If rx0<v.Scale*m/Sqr(tx1*tx1+ty1*ty1) Then i=Len(w.model(model)->mBuild)
      EndIf
      If w.model(model)->mBuild[i]=Asc("z") Then
        'ZoomOut
        i+=1: rx0=w.model(model)->mBuild[i]
        If rx0>v.Scale*m/Sqr(tx1*tx1+ty1*ty1) Then
          Do
            i+=1
            If w.model(model)->mBuild[i]=Asc("C") Then i+=3
            If w.model(model)->mBuild[i]=Asc("D") Then i+=3
            If w.model(model)->mBuild[i]=Asc("O") Then i+=3
            If w.model(model)->mBuild[i]=Asc("L") Then i+=4
            If w.model(model)->mBuild[i]=Asc("T") Then i+=6
            'i+=1
          Loop Until (w.model(model)->mBuild[i+1]=Asc("Z")) _
            Or (w.model(model)->mBuild[i+1]=Asc("z")) _
            Or (i>=Len(w.model(model)->mBuild))
        EndIf
      EndIf
      If w.model(model)->mBuild[i]=Asc("O") Then
        'Color
        i+=1: ucol=w.model(model)->mBuild[i]*&H10000
        i+=1: ucol+=w.model(model)->mBuild[i]*&H100
        i+=1: ucol+=w.model(model)->mBuild[i]
        If ucol=1 Then
          co=col
        Else
          co=ucol
        EndIf
      EndIf
      If w.model(model)->mBuild[i]=Asc("C") Then
        'Circle
        i+=1: rx0=(w.model(model)->mBuild[i]-128)*coorscale
        i+=1: ry0=(w.model(model)->mBuild[i]-128)*coorscale+500
        i+=1: rx1=w.model(model)->mBuild[i]*coorscale*m/v.Scale
        Circle dwin,(xcoor(tx0 +(rx0*tx2+ry0*tx1)/m), _
               ycoor(ty0 +(rx0*ty2+ry0*ty1)/m)), _
               rx1/m*Sqr(tx1*tx1+ty1*ty1)/m,co
      EndIf
      If w.model(model)->mBuild[i]=Asc("D") Then
      'Disc = filled circle
        i+=1: rx0=(w.model(model)->mBuild[i]-128)*coorscale
        i+=1: ry0=(w.model(model)->mBuild[i]-128)*coorscale+500
        i+=1: rx1=w.model(model)->mBuild[i]*coorscale*m/v.Scale
        Circle dwin,(xcoor(tx0 +(rx0*tx2+ry0*tx1)/m), _
               ycoor(ty0 +(rx0*ty2+ry0*ty1)/m)), _
               rx1/m*Sqr(tx1*tx1+ty1*ty1)/m,co,,,,F
      EndIf
      If w.model(model)->mBuild[i]=Asc("L") Then
        'Line
        i+=1: rx0=(w.model(model)->mBuild[i]-128)*coorscale
        i+=1: ry0=(w.model(model)->mBuild[i]-128)*coorscale+500
        i+=1: rx1=(w.model(model)->mBuild[i]-128)*coorscale
        i+=1: ry1=(w.model(model)->mBuild[i]-128)*coorscale+500
        Line dwin,(xcoor(tx0 +(rx0*tx2+ry0*tx1)/m), _
             ycoor(ty0 +(rx0*ty2+ry0*ty1)/m)) _
           -(xcoor(tx0 +(rx1*tx2+ry1*tx1)/m), _
             ycoor(ty0 +(rx1*ty2+ry1*ty1)/m)),co
      EndIf
      If w.model(model)->mBuild[i]=Asc("T") Then
        'Line
        i+=1: rx0=(w.model(model)->mBuild[i]-128)*coorscale
        i+=1: ry0=(w.model(model)->mBuild[i]-128)*coorscale+500
        i+=1: rx1=(w.model(model)->mBuild[i]-128)*coorscale
        i+=1: ry1=(w.model(model)->mBuild[i]-128)*coorscale+500
        i+=1: rx2=(w.model(model)->mBuild[i]-128)*coorscale
        i+=1: ry2=(w.model(model)->mBuild[i]-128)*coorscale+500
        a.x=xcoor(tx0 +(rx0*tx2+ry0*tx1)/m)
        a.y=ycoor(ty0 +(rx0*ty2+ry0*ty1)/m)
        b.x=xcoor(tx0 +(rx1*tx2+ry1*tx1)/m)
        b.y=ycoor(ty0 +(rx1*ty2+ry1*ty1)/m)
        c.x=xcoor(tx0 +(rx2*tx2+ry2*tx1)/m)
        c.y=ycoor(ty0 +(rx2*ty2+ry2*ty1)/m)
        TriDraw(a,b,c,co,dwin)
      EndIf
      i+=1
    Loop
    'debug: show reference point and normal vectors
    If v.Debug Then
      Circle dwin,(xcoor(x1),ycoor(y1)),3,&Hff0000,,,,f
      Circle dwin,(xcoor(x2),ycoor(y2)),3,&Hff0000
      Circle dwin,(xcoor(x1+tx2),ycoor(y1+ty2)),3,&H0000ff
    EndIf
  EndIf
End Sub


Sub ShowItem(P As PItem, dwin As Any Ptr)
  DrawItem(P->a.x,P->a.y,P->b.x,P->b.y,P->build,P->col,dwin)
End Sub


'################################################
'## Functions / Subs (Simulation)
'################################################


Sub AutoPilot(train As PTrain)
  Dim As String Signal
  Dim As Integer sp
  
  If Train->sp>0 Then
    Signal=Train->tr->SigF
  Else
    Signal=Train->tr->SigR
  EndIf
  
  'Auto Pilot Signals
  If (train->control And auto) Then
    
    If Signal="stop" Then  'activate train auto stop
      train->control=train->control Or brake
      train->AutoSpeed=0
    EndIf
    
    If Signal="slow" Then  'activate train slow
      train->control=train->control Or slow
      train->AutoSpeed=0
    EndIf

    If left(Signal,6)="speed:" Then  'activate train slow
      sp=Val(right(Signal,Len(signal)-6))
      If Abs(sp)<1000 Then
        If Train->sp>0 Then
        'set AutoSpeed to signal value
          Train->AutoSpeed=sp
        Else
        'set AutoSpeed to negative value, if train drive backwards
          Train->AutoSpeed=-sp
        EndIf
      EndIf
    EndIf

  EndIf
  
  'Anytime Signals
  If Signal="crash" Then 'activate train crash
    train->control=train->control Or crash
    train->AutoSpeed=0
  EndIf

End Sub


Sub moveTrain(train As PTrain)
  Dim As longint x1, y1, x2, y2 'Calculation needs higher precision

  'Check Train Flag Crash
  If (train->control And crash) Then
    train->sp=0

  'Check Autopilot Brake
  ElseIf (train->control And brake) Then
    If train->sp>0 Then train->sp=train->sp-1
    If train->sp<0 Then train->sp=train->sp+1
    If train->sp=0 Then train->control=train->control And (Not brake)

  'Check Autopilot Slow
  ElseIf (train->control And slow) Then
    If (train->sp>(50*5)) Then train->sp=train->sp-1
    If (train->sp<(-50*5)) Then train->sp=train->sp+1
    If (Abs(train->sp)<=(50*5)) Then train->control=train->control And (Not slow)
  
  'check AutoSpeed
  ElseIf (train->AutoSpeed <>0) Then
    If     (train->AutoSpeed*5) > train->sp Then
      train->sp=train->sp+1
    ElseIf (train->AutoSpeed*5) < train->sp Then
      train->sp=train->sp-1
    Else
      train->AutoSpeed=0
    EndIf
  EndIf

  'calculate train position  
  train->ps=train->ps+train->sp

  'if left track segment forward, set pointer to next
  Do While (train->ps > train->tr->length)
    If train->tr->pf <> 0 Then
      'drive on next track
      train->ps=train->ps-train->tr->length
      train->tr=train->tr->pf
      
      'auto pilot
      AutoPilot(Train)
      
    Else
      'reverse direction if track ends here
      train->sp=-train->sp
      train->ps=0
    EndIf
  Loop
  
  'if left track segment backward, set pointer to last
  Do While (train->ps < 0)
    If train->tr->pr <> 0 Then
      train->ps=train->ps+train->tr->pr->length
      train->tr=train->tr->pr
      
      'auto pilot
      AutoPilot(Train)
      
    Else
      'reverse direction if track ends here
      train->sp=-train->sp
      train->ps=0
    EndIf
  Loop
  
  'calculate X and Y coordinates
  x1=train->tr->x
  y1=train->tr->y
  If train->tr->pf <> 0 Then
    x2=train->tr->pf->x
    y2=train->tr->pf->y
  Else
    x2=x1
    y2=y1
  EndIf

  train->x=(x1*(train->tr->length-train->ps) _
           +x2*train->ps)/train->tr->length
  train->y=(y1*(train->tr->length-train->ps) _
           +y2*train->ps)/train->tr->length

End Sub


Sub PlaceTrack(T As PTrackBase, Tr As PTrack)
  Dim As Integer lng, x, y, z, angle
  '(2) Coordinates
  lng=25*m
  angle=T->anga
  If Left$(Tr->TName,1)="L" Then
    angle=angle-MinAngle*2
  EndIf
  If Left$(Tr->TName,1)="R" Then
    angle=angle+MinAngle*2
  EndIf
  If Left$(Tr->TName,1)="l" Then
    angle=angle-MinAngle
  EndIf
  If Left$(Tr->TName,1)="r" Then
    angle=angle+MinAngle
  EndIf
  If Left$(Tr->TName,1)="s" Then
    lng=25*5*m
  EndIf
  If Left$(Tr->TName,1)="e" Then
    lng=1
  EndIf
  If Len(Tr->TName)=2 Then
    lng=InStr("0123456789",Right$(Tr->TName,1))*lng/5
  EndIf
  angle=angle And &H1ff
  x=T->xa+Cos(angle*pi/256)*lng
  y=T->ya+Sin(angle*pi/256)*lng
  z=T->za
  Tr->angle=angle
  Tr->x=T->xa
  Tr->y=T->ya
  Tr->z=T->za
  'save actual coordinates
  T->anga=angle
  T->xa=x
  T->ya=y
  T->za=z
End Sub


Sub AddTrack(T As PTrackBase, element As String)
  Dim As PTrack tnew
  Dim As Integer lng, x, y, z, xs, ys, zs, angle
  'check if element builds a track
  If InStr(g.BuildTrk,Left$(element,1)) Then
    T->build=T->build+element
    '(1) memory and pointer
    
    'replace "Allocate" by "New" and "DeAllocate" by "Delete" (hint from fxm / FreeBASIC forum)
    'tnew=CAllocate(sizeof(TTrack))
    tnew=New TTrack
    
    tnew->mytrack=T
    tnew->Tname=element
    tnew->pn=0
    tnew->pf=0
    tnew->pr=0
    
    tnew->turn=0

    If element="s" Then
      tnew->SigF="stop"
      tnew->SigR="stop"
    Else
      tnew->SigF=""
      tnew->SigR=""
    EndIf
    
    If T->start=0 Then  'first track segment
      T->start=tnew
      T->last=tnew
      xs=T->x
      ys=T->y
      zs=T->z
      angle=T->angle
      tnew->TNum=1
    Else
      xs=T->last->x
      ys=T->last->y
      zs=T->last->z
      angle=T->last->angle
      T->last->pn=tnew
      T->last->pf=tnew
      tnew->pf=0
      tnew->pr=T->last
      tnew->TNum=T->last->TNum+1
      T->last=tnew
    EndIf
    PlaceTrack(T, tnew)
  EndIf
End Sub


Sub SetTrackSize(tp As PTrack, CalcDistance As integer)
  Dim As Integer a
  'length
  If tp->pf<>0 Then
    tp->length=Sqr((tp->pf->x-tp->x)^2+(tp->pf->y-tp->y)^2)
  Else
    tp->length=25*m
  EndIf
  If tp->pr<>0 Then
    If CalcDistance<>0 Then tp->distance=tp->pr->distance+tp->length
    'precise drawing
    'Speedup: calculate sin/cos during construction
    'tracks fit exactly at connections
    'average value for angle between two tracks
    If Abs(tp->pr->angle-tp->angle)<255 Then
      a=(tp->pr->angle+tp->angle)/2
    Else
      a=(tp->pr->angle+tp->angle)/2+256
    EndIf
    tp->sin0=Sin(a/256*pi)*trackwidth*m
    tp->cos0=Cos(a/256*pi)*trackwidth*m
  EndIf
End Sub


Sub SwitchTurnout(turnout As PTurnout)
  If turnout<>0 Then
    'toggle turnout
    If turnout->turn=1 Then
    'set turn on
      turnout->turn=2
      turnout->pf=turnout->pf2
      'set pointer from outside tracks
      turnout->pr1->pf=turnout->pf2
      turnout->pf2->pr=turnout->pr1
      turnout->pr2->pf=turnout->pf1
      turnout->pf1->pr=turnout->pr2
      SetTrackSize(turnout->pr1, 0)
      SetTrackSize(turnout->pr2, 0)
    Else
    'set turn off
      turnout->turn=1
      turnout->pf=turnout->pf1
      'set pointer from outside tracks
      turnout->pr1->pf=turnout->pf1
      turnout->pf2->pr=turnout->pr2
      turnout->pr2->pf=turnout->pf2
      turnout->pf1->pr=turnout->pr1
      SetTrackSize(turnout->pr1, 0)
      SetTrackSize(turnout->pr2, 0)
    EndIf
  EndIf
End Sub


Sub CloseTrack(T As PTrackBase)
  'connect start and end track segment
  T->start->pr=T->last
  T->last->pf=t->start
End Sub


Sub OpenTrack(T As PTrackBase)
  'connect start and end track segment
  T->start->pr=0
  T->last->pf=0
End Sub


'calculate dimensions and world-coordinates
'use ActivateTrack after track build or change
Sub ActivateTrack(T As PTrackBase)
  Dim As PTrack tp
  'calculate track coordinates
  T->xa=T->x
  T->ya=T->y
  T->za=T->z
  T->anga=T->angle
  'calculate track dimension
  T->dimension.maxx=T->x
  T->dimension.minx=T->x
  T->dimension.maxy=T->y
  T->dimension.miny=T->y
  'loop (1) place track segments
  tp=T->start
  Do
    PlaceTrack(T,tp)
    tp=tp->pn
  Loop Until tp->pn=0
  PlaceTrack(T,tp)
  tp=tp->pf
  
  'loop (2) calculate length and rail position offsets
  tp=T->start
  If tp->pr<>0 Then tp->pr->distance=0
  T->length=0
  Do
    If tp<>0 Then SetTrackSize(tp, tp<>T->Start)
    tp=tp->pn
    If tp<>0 Then
      'Main track length
      T->length=T->length+tp->length
      'calculate main track dimension
      If tp->x > T->dimension.maxx Then T->dimension.maxx = tp->x
      If tp->x < T->dimension.minx Then T->dimension.minx = tp->x
      If tp->y > T->dimension.maxy Then T->dimension.maxy = tp->y
      If tp->y < T->dimension.miny Then T->dimension.miny = tp->y
    EndIf
  Loop Until tp=0
End Sub


'Delete spaces and linebreaks from string
'replace *[n] by n times of last command
Function ExpandTrackString(s As String) As String
  Dim As Integer i, j, k
  Dim As String ds, c
  ds=""
  For i=1 To Len(s)
    If Mid$(s,i,1)>" " Then
      If Mid$(s,i,1)="(" Then
      
        'skip track signal string
        ds=ds+Mid$(s,i,1)
        Do
          i+=1
          ds=ds+Mid$(s,i,1)
        Loop Until Mid$(s,i,1)=")" _
        OrElse i>Len(s)
        
      ElseIf InStr(g.BuildTrk,Mid$(s,i,1)) Then
        'add the build track command
        c=Mid$(s,i,1)
        If InStr("0123456789",Mid$(s,i+1,1)) Then
          c=c+Mid$(s,i+1,1)
          i+=1
        EndIf
        ds=ds+c
      Else
        If Mid$(s,i,1)="*" Then
          'repeat last track build command n times
          If InStr("0123456789",Mid$(s,i+1,1)) Then
            k=0
            Do While InStr("0123456789",Mid$(s,i+1,1))
              k=k+InStr("0123456789",Mid$(s,i+1,1))-1
              i+=1
              If InStr("0123456789",Mid$(s,i+1,1)) Then k=k*10
            Loop
            If (k>1) And (k<100) Then
              For j=1 To k-1
                ds=ds+c
              Next
            EndIf
          EndIf
        EndIf
      EndIf
    EndIf
  Next
  Return ds
End Function


'################################################
'## Create and Delete Objects
'################################################


Sub CreateItem(index As Integer, x1 As Integer, y1 As Integer, x2 As Integer, y2 As Integer, build As Integer, col As Integer, CoorScale As Integer)
  LogFile("Create Item("+str(index)+")")
  If w.Items(index)=NULL Then
    w.Items(index)=New TItem
    w.Items(index)->build=0
    LogFile("  New Item - Memory Reserved")
  Else
    LogFile("  Overwrite Existing Item")
  EndIf
  
  w.Items(index)->a.x=x1
  w.Items(index)->a.y=y1
  w.Items(index)->b.x=x2
  w.Items(index)->b.y=y2
  w.Items(index)->build=build 'house, station, forest...
  w.Items(index)->col=col
  LogFile("  ok")
End Sub


Sub DeleteItem(index As Integer)
  If w.Items(index)<>NULL Then
    LogFile("Delete Item("+str(index)+")")
    DELETE w.Items(index)
    w.Items(index)=NULL
    g.ItemSel=0
    LogFile("  ok")
  EndIf
End Sub


Function NewTrain(Track As Integer, Speed As Integer, _
             Picture As Integer, Length As Integer) As Integer
  Dim As Integer i
  
  'Set i to next free Train Index
  i=0
  Do
    i+=1
  Loop Until (w.Train(i)=NULL) OrElse (i=MaxTrains)
  
  If i<MaxTrains Then
    LogFile("New Train("+str(i)+")")
    If w.Start(Track)=NULL Then
      LogFile("  -Error, Track("+str(Track)+") does not exist.")
    Else
      w.Train(i)=New TTrain
      
      w.Train(i)->sp=Speed
      w.Train(i)->tr=w.Start(Track)->start->pn
      w.Train(i)->ps=0
      w.Train(i)->control=none 'auto
      w.Train(i)->waggons=Length
      w.Train(i)->pic=Picture
      LogFile("  Track="+w.Start(Track)->TName+"")
    EndIf
    LogFile("  ok")
  Else
    LogFile("New Train("+str(i)+") Error - Too much trains")
  EndIf
  NewTrain=i
End Function


Sub DeleteTrain(index As Integer)
  If w.Train(index)<>NULL Then
    LogFile("Delete Train("+str(index)+")")
    DELETE w.Train(index)
    w.Train(index)=0
    v.cam=0
    g.ctrl=0
    LogFile("  ok")
  EndIf
End Sub


Function AddTurnout(t1 As PTrack, t2 As PTrack) As PTurnout
  Dim As PTurnout turnout
  'check if t1 and t2 heve no turnout connects
  If (t1->turn=0) And (t2->turn=0) Then
    LogFile("Add Turnout("+t1->Mytrack->TName+", "+t2->Mytrack->TName+")")
    'memory
    
    'replace "Allocate" by "New" and "DeAllocate" by "Delete" (hint from fxm / FreeBASIC forum)
    'turnout=CAllocate(sizeof(TTurnout))
    turnout=New TTurnout

    'tell the tracks from the turnout
    t1->turn=turnout
    t2->turn=turnout
    'save pointers to connected tracks
    turnout->pr1=t1
    turnout->pr2=t2
    turnout->pf1=turnout->pr1->pf
    turnout->pf2=turnout->pr2->pf
    'set switch coordinates
    turnout->SwitchCoor.x=(t1->x+t2->x)/2
    turnout->SwitchCoor.y=(t1->y+t2->y)/2
    'set turn off
    turnout->turn=1
    'set pointer from outside tracks
    'cross switch
    turnout->pr1->pf=turnout->pf1
    turnout->pf1->pr=turnout->pr1
    turnout->pr2->pf=turnout->pf2
    turnout->pf2->pr=turnout->pr2
    SetTrackSize(turnout->pr1, 0)
    SetTrackSize(turnout->pr2, 0)
    LogFile("  ok")
    Return turnout
  Else
    Return 0
  EndIf
End Function


Sub RemoveTurnout(index As Integer)
  Dim As PTurnout Turnout

  Turnout=w.Turnouts(index)
  If turnout<>NULL Then
    LogFile("Remove Turnout("+Turnout->pr1->Mytrack->TName+", "+Turnout->pr2->Mytrack->TName+")")
    'Cleanup
    'tracks forget the turnout
    turnout->pr1->turn=0
    turnout->pr2->turn=0
    'set pointer from outside tracks
    turnout->pr1->pf=turnout->pf1
    turnout->pf1->pr=turnout->pr1
    turnout->pf2->pr=turnout->pr2
    turnout->pr2->pf=turnout->pf2
    SetTrackSize(turnout->pr1, 0)
    SetTrackSize(turnout->pr2, 0)
    
    'replace "Allocate" by "New" and "DeAllocate" by "Delete" (hint from fxm / FreeBASIC forum)
    'DeAllocate turnout
    Delete turnout
    
    LogFile("  ok")
    w.Turnouts(index)=0
    turnout=0
  EndIf
End Sub


Function NewTrack(trkname As String, sx As Integer, sy As Integer, sz As Integer, angle As Integer) As PTrackBase
  Dim As PTrackBase tinfo

  LogFile("Create New Track("+trkname+")")
  tinfo=New TTrackBase

  'set angle to positive 0..511
  Do While angle<0
    angle=angle+512
  Loop
  angle=angle And 511
  
  tinfo->tname=trkname
  tinfo->build=""
  tinfo->start=0
  tinfo->last=0
  tinfo->x=sx
  tinfo->y=sy
  tinfo->z=sz
  tinfo->angle=angle
  tinfo->xa=sx
  tinfo->ya=sy
  tinfo->za=sz
  tinfo->anga=angle
  tinfo->length=0
  LogFile("  ok")
  Return tinfo
End Function  


Sub DeleteTrack(index As Integer)
  Dim As Integer i, j
  
  If w.Start(index)<>0 Then
    LogFile("Delete Track("+str(index)+") "+w.Start(index)->TName)

    'first delete trains running on that track
    For i=1 To MaxTrains
      If w.Train(i)<>0 Then
        If w.Train(i)->tr->mytrack=w.Start(index) Then
          'delete this train
          DeleteTrain(i)
        EndIf
      EndIf
    Next
    LogFile("  Trains deleted")

    'then delete turnouts
    For i=1 To MaxTurnouts
      If w.Turnouts(i)<>0 Then
        If (w.Turnouts(i)->pr1->mytrack=w.Start(g.trksel)) _
        Or (w.Turnouts(i)->pf1->mytrack=w.Start(g.trksel)) _
        Or (w.Turnouts(i)->pr2->mytrack=w.Start(g.trksel)) _
        Or (w.Turnouts(i)->pf2->mytrack=w.Start(g.trksel)) _
        Then
          'delete this turnout
          RemoveTurnout(i)
        EndIf
      EndIf
    Next
    LogFile("  Turnouts deleted")

    'then delete the track
    g.EditTrkPtr=w.Start(index)->start
    
    j=0
    Do While g.EditTrkPtr<>NULL
      j+=1
      'LogFileNoBr("  "+str(j))

      g.EditTrkPtrA=g.EditTrkPtr
      'LogFileNoBr(".")

      g.EditTrkPtr=g.EditTrkPtr->pn
      'LogFileNoBr(".")

      DELETE g.EditTrkPtrA
      'LogFileNoBr(".")

      If j Mod 10 = 0 Then LogFile("")
    Loop
    
    LogFile("  ##")
    LogFile("  Track deleted")
    Delete w.Start(index)
    w.Start(index)=0
    g.trksel=0
    g.EditTrkPtr=0
    g.EditTrkPtrA=0
    LogFile("  ok")
  EndIf
End Sub




'Build track from a build-string
Function BuildTrack(trkname As String, ByRef s As String, sx As Integer, sy As Integer, sz As Integer, angle As Integer) As PTrackBase
  Dim As String ts, sig
  Dim As PTrackBase newtrk
  Dim As Integer i
  
  LogFile("BuildTrack TrkName="+TrkName)
  ts=ExpandTrackString(s)
  newtrk=NewTrack(trkname, sx, sy, sz, angle)
  i=1
  Do
    If Mid$(ts,i,1)="c" Then
      LogFile("  BuildTrack - Close")
      CloseTrack(newtrk)
      i+=1
    ElseIf Mid$(ts,i,1)="(" Then

      LogFile("  BuildTrack - Signal")

      'Track Signal Fwd
      sig=""
      i+=1
      Do While (Mid$(ts,i,1)<>",") _
      AndAlso (i<Len(ts))
        sig=sig+Mid$(ts,i,1)
        i+=1
      Loop
      newtrk->Last->SigF=sig
      LogFile("BuildTrack SigF="+sig)

      'Track Signal Rev
      sig=""
      i+=1
      Do While (Mid$(ts,i,1)<>")") _
      AndAlso (i<Len(ts))
        sig=sig+Mid$(ts,i,1)
        i+=1
      Loop
      newtrk->Last->SigR=sig
      LogFile("BuildTrack SigR="+sig)


'      'Track Signal Fwd
'      sig=""
'      i+=1
'      Do
'        sig=sig+Mid$(ts,i,1)
'        i+=1
'      Loop Until Mid$(ts,i,1)="," _
'      OrElse i>Len(ts)
'      newtrk->Last->SigF=sig
'      LogFile("BuildTrack SigF="+sig)
'
'      'Track Signal Rev
'      sig=""
'      i+=1
'      Do
'        sig=sig+Mid$(ts,i,1)
'        i+=1
'      Loop Until Mid$(ts,i,1)=")" _
'      OrElse i>Len(ts)
'      newtrk->Last->SigR=sig
'      LogFile("BuildTrack SigR="+sig)



    ElseIf InStr("0123456789",Mid$(ts,i+1,1)) Then
      AddTrack(newtrk, mid$(ts,i,2))
      i+=2
    Else
      AddTrack(newtrk, mid$(ts,i,1))
      i+=1
    EndIf
  Loop Until(i>Len(ts))
  ActivateTrack(newtrk)
  LogFile("  BuildTrack - ok")
  Return newtrk
End Function


'add turnout, return turnout index
Function InstallTurnout(p1 As PTrackBase, i1 As Integer, _
    p2 As PTrackBase, i2 As Integer) As Integer
  Dim As PTrack tp1, tp2
  Dim As Integer i
  tp1=p1->start
  For i=1 To i1
    If tp1->pn<>0 Then tp1=tp1->pn
  Next
  tp2=p2->start
  For i=1 To i2
    If tp2->pn<>0 Then tp2=tp2->pn
  Next
  i=0
  Do
    i+=1
  Loop Until (w.Turnouts(i)=0) OrElse (i>MaxTurnouts)

  If i<=MaxTurnouts Then
    w.Turnouts(i)=AddTurnout(tp1, tp2)
  EndIf
  InstallTurnout=i
End Function





'################################################
'## Little helper
'################################################


'get index number of track by name
Function NumOfTrack(s As String) As Integer
  Dim As Integer i, r
  
  For i=0 To MaxTracks
    If w.Start(i)<>NULL AndAlso w.Start(i)->TName=s Then
      r=i
      Exit For
    EndIf
  Next i
  NumOfTrack=r
End Function


'get model index number by name
Function NumOfModel(s As String) As Integer
  Dim As Integer i, r

  r=0
'  Print
'  Print "NumOfModel ("+s+")";
  For i=1 To MaxModels
    If w.Model(i)<>NULL Then
'      Print " i="+str(i)+", MName="+w.Model(i)->MName
      If w.Model(i)->MName=s Then
        r=i
'        Print
'        Print "return r="+str(r)
        Exit For
      EndIf
    EndIf
  Next i
'  Print
  NumOfModel=r
End Function


Function fstr(num As Single, LDigits As Integer, RDigits As Integer) As String
  Dim As String s
  Dim As Integer i
  Dim As Single n
  If num>(10^(LDigits)) Then
    s="#OE#"
  ElseIf -num>(10^(LDigits-1)) Then
    s="#OE#"
  Else
    s=Right(String(LDigits,"0")+Str(Int(Abs(num))),LDigits)+"."
    If RDigits>0 Then
      n=num-Int(num)
      For i=1 To RDigits
        n=n*10
        s=s+Chr(Asc("0")+n Mod 10)
      Next
    EndIf
    If num<0 Then s[0]=Asc("-")
  EndIf
  Function=s
End Function


Sub DrawTextBottom(dwin As Any Ptr, msg As String, _
        wleft As Integer, wright As Integer, _
        bgtype As Integer, bgcolor As Integer)
  
  Dim As Integer y, l, i, p
  Dim As String ms
  
  ms=msg
  'count and return l=lines
  l=0
  For i=1 To Len(ms)
    If mid(ms,i,1)="|" Then
      l+=1
    EndIf
  Next i
  
  'cls
  If bgtype=1 Then
    Line dwin, (wleft, v.WinY-(l)*10-4)-(wright, v.WinY), bgcolor, BF
  EndIf
  
  p=InStr(ms,"|")
  For i=0 To l-1
    GfxPrint6 left(ms, p-1), wleft+2, v.WinY-l*10-2+i*10, CTextColor, dwin
    ms=right(ms,Len(ms)-p)
    p=InStr(ms,"|")
  Next i
End Sub


Function InputBox(title As String, s As String) As String
  Const IBoxX=200
  Const IBoxY=50
  Dim As Any Ptr img = ImageCreate(IBoxX, IBoxY, CMsgBoxColor)
  Dim As String k
  
  Do
    k=InKey$
    If k>=" " Then
      s=s+k
    ElseIf k=chr(8) Then
      s=left(s, Len(s)-1)
    EndIf
    Line img,(2,2)-(IBoxX-3,IBoxY-3),CTextColor,B
    GfxPrint6 title, 20, 10, CTextColor, img
    GfxPrint6 s+chr(254), 20, 30, CTextColor, img
    Put ((480-IBoxX)/2, (480-IBoxY)/2), img, PSet
    Sleep 10
    Line img,(0,0)-(IBoxX-1,IBoxY-1),CMsgBoxColor,BF
  Loop Until (k=chr(10)) OrElse (k=chr(13)) OrElse (k=chr(27))

  InputBox=s
End Function


Function YesOrNoBox(title As String) As String
  Const IBoxX=240
  Const IBoxY=50
  Dim As Any Ptr img = ImageCreate(IBoxX, IBoxY, CMsgBoxColor)
  Dim As String k
  
  Line img,(2,2)-(IBoxX-3,IBoxY-3),CTextColor,B
  'print to center
  GfxPrint6 title, (IBoxX-Len(title)*6)/2, 10, CTextColor, img
  GfxPrint6 "Press y or n (yes/no)", (IBoxX-21*6)/2, 30, CTextColor, img
  Put ((480-IBoxX)/2, (480-IBoxY)/2), img, PSet
  Do
    Sleep 50
    k=lcase(InKey$)
  Loop Until (k="y") OrElse (k="n") OrElse (k=chr(27))
  YesOrNoBox=k
End Function


Sub MessageBox(title As String)
  Const IBoxX=320
  Const IBoxY=50
  Dim As Any Ptr img = ImageCreate(IBoxX, IBoxY, CMsgBoxColor)
  Dim As String k
  
  Line img,(2,2)-(IBoxX-3,IBoxY-3),CTextColor,B
  'print to center
  GfxPrint6 title, (IBoxX-Len(title)*6)/2, 10, CTextColor, img
  GfxPrint6 "Press a key.", (IBoxX-12*6)/2, 30, CTextColor, img
  Put ((480-IBoxX)/2, (480-IBoxY)/2), img, PSet
  Do
    Sleep 50
    k=lcase(InKey$)
  Loop Until k<>""
End Sub


Sub InfoBox(title As String)
  Const IBoxX=320
  Const IBoxY=50
  Dim As Any Ptr img = ImageCreate(IBoxX, IBoxY, CMsgBoxColor)
  Dim As String k
  
  Line img,(2,2)-(IBoxX-3,IBoxY-3),CTextColor,B
  'print to center
  GfxPrint6 title, (IBoxX-Len(title)*6)/2, 20, CTextColor, img
  Put ((480-IBoxX)/2, (480-IBoxY)/2), img, PSet
End Sub


'################################################
'## Train simulation
'################################################


Sub world_sim
  Dim As Integer i
  'move train
  For i=1 To maxtrains
    If w.Train(i)<>0 Then
      MoveTrain(w.Train(i))
    EndIf
  Next
End Sub


Function IsTrainVisible(i As Integer) As Integer
  Dim As Integer j, isvisible
  Dim As TTrain waggon
  If w.Train(i)<>0 Then
    'check if train or waggons are visible
    isvisible=visible(w.Train(i)->x,w.Train(i)->y)
    'calculate waggons positions
    waggon.tr=w.Train(i)->tr
    waggon.ps=w.Train(i)->ps
    waggon.control=none
    waggon.sp=-10*m  'Distance between waggons
    For j=1 To w.Train(i)->waggons*2+1
      moveTrain(@waggon) '"walk on track" to next waggon
      If j=1 Then
        waggon.sp=-6*m
      Else
        If (j Mod 2)=0 Then
          waggon.sp=-10*m
        Else
          waggon.sp=-6*m
        EndIf
      EndIf
      If visible(waggon.x,waggon.y) Then isvisible+=1
    Next
  EndIf
  Function=isvisible
End Function


'################################################
'## render world graphics
'################################################


Sub world_render(dwin As Any Ptr, show As Integer)

  'show bit 0: print fps and scale info
  'show bit 1: print train speed and track info
  'show bit 2: print train number
  Dim As PMapR Map1
  Dim As Integer i,j,wagx,wagy,col
  Dim As Long x1,x2,cx,y1,y2,cy,cFade
  Dim As TTrain waggon
  Dim As PTurnout Turnout
  Dim As String s    'temporary string
    
    'Cls
    Line dwin,(0,0)-(v.WinX-1,v.WinY-1),GroundColor,BF
    
    'check If camera Point To a valid train
    If w.Train(v.cam)=NULL Then
      v.cam=0
    EndIf
    
    'camera follows train

    If v.cam<>0 Then
      If (v.CamSlide<>0) Then
'      AndAlso (v.OldCam<>0) _
'      AndAlso (v.Cam<>0) Then
        cfade=v.CamSlide
        
        x1=v.OldCamX          /100
        x2= w.Train(v.Cam)->x /100
        y1=v.OldCamY          /100
        y2= w.Train(v.Cam)->y /100
        
        cx=(cFade * x1 + (CCamSteps-cFade)*x2)/CCamSteps
        cy=(cFade * y1 + (CCamSteps-cFade)*y2)/CCamSteps
        
        cx=cx*100
        cy=cy*100

        ScreenCenter(cx,cy)
        If v.CamSlide Then
          v.CamSlide-=1
        EndIf
      Else
        ScreenCenter(w.Train(v.cam)->x, w.Train(v.cam)->y)
      EndIf
    EndIf

'    If v.cam<>0 Then
'      ScreenCenter(w.Train(v.cam)->x, w.Train(v.cam)->y)
'    EndIf


    '################################################
    '## simple map of random green colors
    '################################################

    #if mapon
      'draw map
      If show And 1 AndAlso v.mapactive Then
        map1=w.map
        Do While (map1->pnext<>0)
          If visrect(map1->x1,map1->y1,map1->x2,map1->y2) Then
            Line dwin,(xcoor(map1->x1),ycoor(map1->y1)) _
            -(xcoor(map1->x2),ycoor(map1->y2)), map1->Color, BF
          EndIf
          map1=map1->pnext
        Loop
      EndIf
      
    #endif


    '################################################
    '## show a bmp-picture as map
    '################################################


    #if landmapon
    
      Dim As Integer x, y, mpx, mpy
      Dim As Double tnow

      'GfxPrint6 "maph="+str(maph)+" mapw="+str(mapw),320,8,&HFFFFFF,dwin


      'Draw using Pseudo-array / Bitmap array (fastest version)
      'See FreeBASIC Manual, ImageInfo performance example
      'draw map
      tnow=timer    'performance watch
      Dim As Integer map_pitch, k
      Dim As Any Ptr map_pix
      If v.landmapactive Then
        If 0=ImageInfo (dwin,,,, map_pitch, map_pix,) Then
          For i=0 To MaxBmp
            If (Timer-tnow)*1000<MapPerformance _
            AndAlso w.MapHdr(i)<>0 _
            AndAlso w.MapHdr(i)->ZoomMin <= v.scale _
            AndAlso w.MapHdr(i)->ZoomMax >= v.scale _            
            Then
              j=w.MapHdr(i)->BmpIndex
              For y=0 To v.WinX-1 Step 1
                mpy = (p2wy(y)-w.MapHdr(i)->y)/w.MapHdr(i)->scale
                If (mpy>=0) _
                  AndAlso (mpy<w.MapData(j)->h) Then
                  Dim maprow As UInteger Ptr = map_pix + y * map_pitch
                  For x=0 To v.WinY-1 Step 1
                    mpx = (p2wx(x)-w.MapHdr(i)->x)/w.MapHdr(i)->scale
                    If (mpx>=0) AndAlso (mpx<w.MapData(j)->w) Then
                      k=w.MapData(j)->data(mpx, mpy)
'                      If k<>invisiblecolor Then
                        maprow[x] = k
'                      EndIf

'                      maprow[x] = w.MapData(j)->data(mpx, mpy)

                    EndIf
                  Next x
                EndIf
              Next y
            EndIf
          Next i
        EndIf
      EndIf


'      'Draw using Pseudo-array / Bitmap array (fastest version)
'      'See FreeBASIC Manual, ImageInfo performance example
'      'draw map
'      tnow=timer    'performance watch
'      Dim As Integer map_pitch, k
'      Dim As Any Ptr map_pix
'      If v.landmapactive Then
'        If 0=ImageInfo (dwin,,,, map_pitch, map_pix,) Then
'          For i=0 To MaxBmp
'            If (Timer-tnow)*1000<MapPerformance _
'            AndAlso w.MapHdr(i)<>0 _
'            AndAlso w.MapHdr(i)->ZoomMin < v.scale _
'            AndAlso w.MapHdr(i)->ZoomMax > v.scale _            
'            Then
'              j=w.MapHdr(i)->BmpIndex
'              For y=0 To v.WinX-1 Step 1
'                mpy = (p2wy(y)-w.MapHdr(i)->y)/w.MapHdr(i)->scale
'                If (mpy>=0) _
'                  AndAlso (mpy<w.MapData(j)->h) Then
'                  Dim maprow As UInteger Ptr = map_pix + y * map_pitch
'                  For x=0 To v.WinY-1 Step 1
'                    mpx = (p2wx(x)-w.MapHdr(i)->x)/w.MapHdr(i)->scale
'                    If (mpx>=0) AndAlso (mpx<w.MapData(j)->w) Then
'                      k=w.MapData(j)->data(mpx, mpy)
''                      If k<>invisiblecolor Then
'                        maprow[x] = k
''                      EndIf
'
''                      maprow[x] = w.MapData(j)->data(mpx, mpy)
'
'                    EndIf
'                  Next x
'                EndIf
'              Next y
'            EndIf
'          Next i
'        EndIf
'      EndIf


'      'Draw using Pseudo-array / Bitmap array (fastest version)
'      'See FreeBASIC Manual, ImageInfo performance example
'      'draw map
'      Dim As Integer map_pitch
'      Dim As Any Ptr map_pix
'      If v.landmapactive Then
'        If 0=ImageInfo (dwin,,,, map_pitch, map_pix,) Then
'          
'          For y=0 To v.WinX-1 Step 1
'            mpy = (p2wy(y)-w.MapHdr(0)->y)/w.MapHdr(0)->scale
'            If (mpy>=0) _
'              AndAlso (mpy<w.MapData(0)->h) Then
'              Dim maprow As UInteger Ptr = map_pix + y * map_pitch
'              For x=0 To v.WinY-1 Step 1
'                mpx = (p2wx(x)-w.MapHdr(0)->x)/w.MapHdr(0)->scale
'                If (mpx>=0) _
'                  AndAlso (mpx<w.MapData(0)->w) Then
'                  maprow[x] = w.MapData(0)->data(mpx, mpy)
'                EndIf
'              Next x
'            EndIf
'          Next y
'          
'        EndIf
'      EndIf


'      'Draw using Pseudo-array / Bitmap array (fastest version)
'      'See FreeBASIC Manual, ImageInfo performance example
'      'draw map
'      Dim As Integer map_pitch
'      Dim As Any Ptr map_pix
'      If v.landmapactive Then
'        If 0=ImageInfo (dwin,,,, map_pitch, map_pix,) Then
'          For y=0 To v.WinX-1 Step 1
'            mpy = (p2wy(y)-mapposy)/mapscale
'            If (mpy>=0) AndAlso (mpy<maph) Then
'              Dim maprow As UInteger Ptr = map_pix + y * map_pitch
'              For x=0 To v.WinY-1 Step 1
'                mpx = (p2wx(x)-mapposx)/mapscale
'                If (mpx>=0) AndAlso (mpx<mapw) Then
'                  maprow[x] = maparray(mpx, mpy)
'                EndIf
'              Next x
'            EndIf
'          Next y
'        EndIf
'      EndIf



'      'Draw using PSet / Bitmap array (faster version)
'      'draw map
'       If v.landmapactive Then
'        For y=0 To v.WinX-1 Step 1
'          mpy = (p2wy(y)-mapposy)/mapscale
'          If (mpy>=0) AndAlso (mpy<maph) Then
'            For x=0 To v.WinY-1 Step 1
'              mpx = (p2wx(x)-mapposx)/mapscale
'              If (mpx>=0) AndAlso (mpx<mapw) Then
'                PSet dwin, (x,y),maparray(mpx, mpy)
'              EndIf
'            Next x
'          EndIf
'        Next y
'      EndIf



'      'Draw using PSet / Point (very slow)
'      'draw map
'      If v.landmapactive Then
'        For y=0 To v.WinY-1
'          mpy = (p2wy(y)-mapposy)/mapscale
'          If (mpy>=0) AndAlso (mpy<maph) Then
'            For x=0 To v.WinX-1
'              mpx = (p2wx(x)-mapposx)/mapscale
'              If (mpx>=0) AndAlso (mpx<mapw) Then
'                PSet dwin, (x,y), Point(mpx, mpy, map)
'              EndIf
'            Next x
'          EndIf
'        Next y
'      EndIf



    #endif





    
    'draw grid
    If v.gridon Then drawgrid(0,0,worldx,worldy, _
      (Left$(ks,3)=K_edittrackFlag) Or (g.ItemSel<>0), dwin)
    
    'draw tracks
    For i=1 To maxtracks
      'check if track exist (Vector <> 0)
      If w.Start(i)<>0 Then
        'check if track is visible on screen
        If visrect(w.Start(i)->dimension.minx, w.Start(i)->dimension.miny, _
           w.Start(i)->dimension.maxx, w.Start(i)->dimension.maxy) Then
          DrawTrack(w.Start(i), g.trksel=i, dwin)
        EndIf
      EndIf
    Next
    
    
    'draw train
    For i=1 To maxtrains
      'check if train exist (pointer<>0)
      If w.Train(i)<>0 Then
        'check if train is visible
        If IsTrainVisible(i)>0 Then
          col=&H8080e0  'Train color
          If i=g.ctrl Then col=&Hc0c0ff 'Highlightet train
          If i=g.ctrl And (w.Train(i)->control And auto) Then col=&H80ff80  'Color of auto controlled train
          If w.Train(i)->control And brake Then col=&Hff8080  'Color of braking train
          waggon.tr=w.Train(i)->tr
          waggon.ps=w.Train(i)->ps
          waggon.control=none
          waggon.sp=-10*m  'Distance between waggons (Loc size)
          For j=1 To w.Train(i)->waggons*2+1
            moveTrain(@waggon) '"walk on track" to next waggon
            If j=1 Then
              'Locomotive (Distance)
              DrawItem(w.Train(i)->x,w.Train(i)->y, _
              waggon.x,waggon.y,w.Train(i)->pic,col,dwin)
              waggon.sp=-6*m  'Distance between waggons
            Else
              If (j Mod 2)=0 Then
                wagx=waggon.x
                wagy=waggon.y
                waggon.sp=-10*m  'waggon length
              Else
                'Waggon
                DrawItem(wagx,wagy, _
                waggon.x,waggon.y, Locomotives+2, &H80e080,dwin)
                waggon.sp=-6*m  'Distance between waggons
              EndIf
            EndIf
          Next
          
          'Print train number
          If show And 4 Then
            GFXPrint(Str$(i),xcoor(w.Train(i)->x)+8,ycoor(w.Train(i)->y)-16,&Hffffff,dwin)
          EndIf
        EndIf
      EndIf
    Next
    
    'First draw all items
    For i=1 To MaxItems
      If w.Items(i)<>0 Then 
        ShowItem(w.Items(i),dwin)
      EndIf
    Next
    
    'Then check if one item is selected
    'If yes, bring it to front (draw it again)
    If show And 2 Then 
      For i=1 To MaxItems
        If w.Items(i)<>0 Then 
          If i=g.ItemSel Then
            g.ItemSelName=w.Model(w.Items(i)->build)->mName+" ("+str(i)+")"
            ShowItem(w.Items(i),dwin)
            Circle dwin,(xcoor(w.Items(i)->a.x),ycoor(w.Items(i)->a.y)),20,&Hffff00
            Circle dwin,(xcoor(w.Items(i)->b.x),ycoor(w.Items(i)->b.y)),20,&H0080ff
            GfxPrint6 g.ItemSelName,xcoor(w.Items(i)->a.x)-(3*Len(g.ItemSelName)),ycoor(w.Items(i)->a.y)-30,&HFFFFFF,dwin
          Else
            g.ItemSelName=""
          EndIf
        EndIf
      Next
      
      'Draw turnout switches
      For i=1 To MaxTurnouts
        If w.Turnouts(i)<>0 Then
          If visible(w.Turnouts(i)->SwitchCoor.x, _
              w.Turnouts(i)->SwitchCoor.y) Then
            Line dwin,(xcoor(w.Turnouts(i)->pr1->x),ycoor(w.Turnouts(i)->pr1->y)) _
              - (xcoor(w.Turnouts(i)->pr2->x),ycoor(w.Turnouts(i)->pr2->y)),&Hc0c000
            If w.Turnouts(i)->turn=2 Then
              Circle dwin,(xcoor(w.Turnouts(i)->SwitchCoor.x), _
                ycoor(w.Turnouts(i)->SwitchCoor.y)),2+1*m/v.Scale,&H0000ff
            Else
              Circle dwin,(xcoor(w.Turnouts(i)->SwitchCoor.x), _
                ycoor(w.Turnouts(i)->SwitchCoor.y)),2+1*m/v.Scale,&H00ff00
            EndIf
          EndIf
        EndIf
      Next
      
      'Draw selected Tracksegment highlighted
      If g.EditTrkPtr<>0 Then
        DrawSubTrackHighlighted(g.EditTrkPtr,&Hffff00,dwin)
      EndIf
      
      If g.EditTrkPtrA<>0 Then
        DrawSubTrackHighlighted(g.EditTrkPtrA,&Hff0000,dwin)
      EndIf
    EndIf
    
    
    '################################################
    '## Main (Print status info)
    '################################################
    

    'Print help/info screen
    If show And 1 Then











      If helpman AndAlso _
        Left$(ks,3)<>K_edittrackFlag Then
        
        If v.gridon Then 
          If v.Scale>100000 Then
            s="(10km)"
          ElseIf v.Scale>10000 Then
            s="(1km)"
          ElseIf v.Scale>1000 Then
            s="(100m)"
          ElseIf v.Scale>100 Then
            s="(10m)"
          Else
            s="(1m)"
          EndIf
        Else
          s=""
        EndIf
    
    
        DrawTextBottom(dwin, _
           "Train Simulator  proog.de|"_
          +"-------------------------|"_
          +"F1-F3 Display|"_
          +" 0-9  Watch Train #|"_
          +"  f   File Load|"_
          +"  F   File Save|"_
          +"  g   Show Grid "+s+"|"_
          +"  m   Show Map|"_
          +"  d   Debug View|"_
          +" CURS Move Camera|"_
          +" PAGE Up/Dn Zoom|"_
          +"|"_
          +" ESC  End Program|"_
          , 0, 158, helpman, &H104020 _
        )


        'context sensitive display
        If g.trksel Then
          'Track is selected, can start editor
          'GfxPrint6 "*Track "+str(g.trksel)+"*",0,0*8+402,&HFFFFFF,dwin
          DrawTextBottom(dwin, _
             "Track "+str(g.trksel)+" "+w.Start(g.trksel)->TName+"|"_
            +"-------------------------|"_
            +"MOUSE Move|"_
            +"  n   Place New Train|"_
            +"  i   Input Track Name|"_
            +"  e   Track Editor|"_
            +" </>  Rotate|"_
            +" DEL  Delete Track|"_
            , 320, 479, helpman, &H104020 _
          )

        ElseIf g.ItemSel Then
          'Item is selected, can move
          DrawTextBottom(dwin, _
             "Item "+str(g.ItemSel)+" "+_
                    w.Model(w.Items(g.ItemSel)->build)->mName+"|"_
            +"-------------------------|"_
            +"MOUSE Move/Size|"_
            +" +/-  Change Model|"_
            +" DEL  Delete|"_
            , 320, 479, helpman, &H104020 _
          )

        ElseIf g.ctrl Then
          'Train is selected, can be controlled
          If Int(w.Train(g.ctrl)->sp*2/10)=0 Then
            If w.Train(g.ctrl)->control And crash Then
              s="Train Crashed"     'train has crashed
            ElseIf "s"=w.Train(g.ctrl)->tr->TName Then
              s="Rail Station"      'train stops at station, maybe make some money
            Else
              s="Stop On Track"     'train stops on track
            EndIf
          Else
            s=""
          EndIf
          
          Dim As String s1, s2

          s1=""
          If g.ctrl<>0 Then
            If w.Train(g.ctrl)->control And auto Then
              s1=" (A)"
              If w.Train(g.ctrl)->control And brake Then
                s1=" (S)"
              EndIf
            EndIf
            s2="(Flags "+hex(w.Train(g.ctrl)->control,4)+")"
          EndIf
          
          DrawTextBottom(dwin, _
             "Train "+str(g.ctrl) _
            +":"+str(w.Train(g.ctrl)->waggons) _
            +" "+w.model(w.Train(g.ctrl)->pic)->mName+"|"_
            +"Speed "+str(Int(w.Train(g.ctrl)->sp*2/10))+" "+s+"|" _
            +"-------------------------|"_
            +"  a   Assist Driver"+s1+"|"_
            +"  s   Stop - "+s2+"|"_
            +" l/.  Speed Fwd|"_
            +" k/,  Speed Rev|"_
            +" u/U  Next/Prev Turnout|"_
            +" TAB  Select Next Train|"_
            +"  w   Watch Train|"_
            +"  t   Watch Track|"_
            +" +/-  Train Length|"_
            +"  b   Beam To Next Track|"_
            , 320, 479, helpman, &H104020 _
          )
          
        Else
          'Nothing selected
          DrawTextBottom(dwin, _
             "MOUSE |"_
            +"CLICK Select Object|"_
            +"DRAG  Move Map|"_
            +"WHEEL Zoom|"_
            +"-------------------------|"_
            +"  n   New Item @ Mousepos|"_
            +" INS  New Track @ Mousep.|"_
            +" DEL  Delete World|"_
            , 320, 479, helpman, &H104020 _
          )
        EndIf


      EndIf
    EndIf
    
    
    
    'Print track editor info
    If show And 8 Then
      If Left$(ks,3)=K_edittrackFlag Then 
      
        If g.trksel Then
          'Track is selected, can start editor
          'GfxPrint6 "*Track "+str(g.trksel)+"*",0,0*8+402,&HFFFFFF,dwin
          DrawTextBottom(dwin, _
             "Edit Track "+str(g.trksel)+" "+w.Start(g.trksel)->TName+"|"_
            +"-------------------------|"_
            +"MOUSE Move Track|"_
            +" +/-  Move Track Cursor|"_
            +" o/c  Open/Close Track|"_
            +" INS  New Track Segment|"_
            +" DEL  Delete Track Seg.|"_
            +" l/r  Track Left/Right|"_
            +" L/R  Sharp Left/Right|"_
            +"  f   Track Forward|"_
            +"  s   Rail Station|"_
            +"  i   Input Signal F/R|"_
            +" 0-9  Length|"_
            +"  e   End Track Editor|"_
            , 320, 479, helpman, &H104020 _
          )

        ElseIf g.ItemSel Then
          'Item is selected, can move
          DrawTextBottom(dwin, _
             "*Item "+str(g.ItemSel)+" "+_
                    w.Model(w.Items(g.ItemSel)->build)->mName+"|"_
            +"-------------------------|"_
            +"MOUSE Move/Size|"_
            +" +/-  Change Model|"_
            +" DEL  Delete|"_
            , 320, 479, helpman, &H104020 _
          )

        ElseIf g.ctrl Then
          'Train is selected, can be controlled
          If Int(w.Train(g.ctrl)->sp*2/10)=0 Then
            If "s"=w.Train(g.ctrl)->tr->TName Then
              s="Rail Station"      'train stops at station, maybe make some money
            Else
              s="Stop On Track"     'train stops on track
            EndIf
          Else
            s=""
          EndIf
          
          
          DrawTextBottom(dwin, _
             "*Train "+str(g.ctrl)+" "+_
                    w.model(w.Train(g.ctrl)->pic)->mName+"|"_
            +"Speed "+str(Int(w.Train(g.ctrl)->sp*2/10))+" "+s+"|"_
            +"-------------------------|"_
            +"  s   Stop|"_
            +"  a   Auto Halt|"_
            +" l/.  Speed Fwd|"_
            +" k/,  Speed Rev|"_
            +" u/U  Next/Prev Turnout|"_
            +" TAB  Select Next Train|"_
            +"  w   Watch Train|"_
            +"  t   Watch Track|"_
            +" +/-  Train Length|"_
            +"  b   Beam To Next Track|"_
            , 320, 479, helpman, &H104020 _
          )
          
        Else
          'Nothing selected
          DrawTextBottom(dwin, _
             "*MOUSE |"_
            +"CLICK To Select|"_
            +"DRAG  Move Map|"_
            +"WHEEL Zoom|"_
            +"-------------------------|"_
            +"  n   New Item @ Mousepos|"_
            +" INS  New Track @ Mousep.|"_
            , 320, 479, helpman, &H104020 _
          )
        EndIf
      





        
        
        Line dwin,(0,48)-(28*6+4,162),&H104020,BF
        GfxPrint6 "** Track editor ** ["+ks+"]",2,50,&HFFFFFF,dwin
        
        If g.EditTrkBasePtr<>0 Then
          GfxPrint6 " "+g.EditTrkBasePtr->tname _
            ,2,60,&HFFFFFF,dwin
        EndIf
        
        'Draw selected Tracksegment highlighted
        
        If g.EditTrkPtr<>0 Then
          GfxPrint6 " #="+Str$(Int(g.EditTrkPtr->tnum))+ _
            " Name="+g.EditTrkPtr->tname _
            ,2,80,&Hffffff,dwin
          GfxPrint6 " length="+Str$(Int(g.EditTrkPtr->length/m*10)/10)+ _
            " distance="+Str$(Int(g.EditTrkPtr->distance/m*10)/10) _
            ,2,90,&Hffffff,dwin
          GfxPrint6 " Turnout="+Str$(Abs(g.EditTrkPtr->turn<>0)) _
            ,2,100,&Hffffff,dwin
          GfxPrint6 " X="+Str$(Int(g.EditTrkPtr->x/m*10)/10) _
            ,2,110,&Hffffff,dwin
          GfxPrint6 " Y="+Str$(Int(g.EditTrkPtr->y/m*10)/10) _
            ,2,120,&Hffffff,dwin
          GfxPrint6" Z="+Str$(Int(g.EditTrkPtr->z/m*10)/10)+ _
            " <="+Str$(Int(g.EditTrkPtr->angle)) _
            ,2,130,&Hffffff,dwin

          GfxPrint6 " Fwd Signal="+g.EditTrkPtr->SigF _
            ,2,140,&Hffffff,dwin
          GfxPrint6 " Rev Signal="+g.EditTrkPtr->SigR _
            ,2,150,&Hffffff,dwin

'          GfxPrint6 " Fwd Signal="+Str$(g.EditTrkPtr->sigf.Signaltype)+ _
'            " SigValue="+Str$(g.EditTrkPtr->sigf.SignalValue) _
'            ,2,140,&Hffffff,dwin
'          GfxPrint6 " Rev Signal="+Str$(g.EditTrkPtr->sigr.Signaltype)+ _
'            " SigValue="+Str$(g.EditTrkPtr->sigr.SignalValue) _
'            ,2,150,&Hffffff,dwin

        EndIf  
  
      EndIf

    EndIf


    '################################################
    '## OHD - FPS and Scale
    '################################################

      
    If show And 2 AndAlso ohdfps Then
      If ohdfps=1 Then
        Line dwin,(0,0)-(v.WinX-1,39),&H104020,BF
      EndIf
      GfxPrint6 "FPS="+Str$(Int(g.Fps))+"/"+Str$(Int(g.Fps0))_
        +" Skip="+Str$(g.SkipFrame)_
        +" AvTm="+Str$(Int(g.AvgTime*1000))_
        +" AMax="+Str$(Int(g.AvgMax*1000))_
        +" Scale=1/"+Str$(v.Scale) _
        ,0,0,&Hffffff,dwin
'        GfxPrint6 "FPS="+Str$(Int(g.Fps*10)/10)+"/"+Str$(Int(g.Fps0*10)/10)+ _
'          " Skip="+Str$(g.SkipFrame)+" Scale=1/"+Str$(v.Scale) _
'          ,0,0,&Hffffff,dwin

'        'Scale
'
'        GfxPrint6 "Scale=1/"+Str$(v.Scale) _
'          ,0,0,&Hffffff,dwin


      'GPS
      
      Dim As String gpsxh, gpsxl, gpsyh, gpsyl
      
      gpsxh=Str$(Int(p2wx(v.WinX/2)/m))
      gpsxl=right(gpsxh,3)
      gpsxh=left(gpsxh,Len(gpsxh)-3)
      gpsyh=Str$(Int(p2wy(v.WinY/2)/m))
      gpsyl=right(gpsyh,3)
      gpsyh=left(gpsyh,Len(gpsyh)-3)
      GfxPrint6 "GPS X="+gpsxh+"."+gpsxl+ _    
                " Y="+gpsyh+"."+gpsyl,320,0,&Hffffff,dwin      
    EndIf
    
    If g.ctrl>0 Then: i=g.ctrl: Else: i=1: EndIf
   
    If show And 2 AndAlso ohdfps Then
      If g.ctrl<>0 Then
        '### Error displaying negative speed
        s="Train="+Str$(g.ctrl)+" Sp="+fstr((w.Train(g.ctrl)->sp*2)/10,3,2)+ _
          " Track="+w.Train(g.ctrl)->tr->mytrack->tname
        If (v.cam<>0) And (v.cam<>g.ctrl) Then
          s=s+" (Watch train "+Str$(v.cam)+")"
        EndIf
        GfxPrint6 s,0,8,&Hffffff,dwin
      EndIf
    EndIf
    

'    If show And 1 AndAlso v.gridon Then
'      If helpman Then
'        i=390
'      Else
'        i=v.WinY-10
'      EndIf
'      
'      If v.Scale>100000 Then
'        GfxPrint6 "Grid 10km",0,i,&Hffffff,dwin
'      ElseIf v.Scale>10000 Then
'        GfxPrint6 "Grid 1km",0,i,&Hffffff,dwin
'      ElseIf v.Scale>1000 Then
'        GfxPrint6 "Grid 100m",0,i,&Hffffff,dwin
'      ElseIf v.Scale>100 Then
'        GfxPrint6 "Grid 10m",0,i,&Hffffff,dwin
'      Else
'        GfxPrint6 "Grid 1m",0,i,&Hffffff,dwin
'      EndIf
'      
'    EndIf

    If show And 1 Then
      If MsgCnt>0 Then
        MsgCnt-=1
        Line dwin,(32,v.WinY/2-16)-(v.WinX-30,v.WinY/2+20),&H104020,BF
        GfxPrint6 NewMessage,(v.WinX-6*Len(NewMessage))/2,v.WinY/2,&Hffffff,dwin
      EndIf
    EndIf

    If g.Mousehold>g.Fps/click Then
      'hide mouse on drag
      'GfxPrint6 "* DRAG *",8,32,&Hffffff,dwin
      setmouse ,,0
    Else
      setmouse ,,1
    EndIf

    
    If v.Debug Then
      
      'draw border (debug/test)
#ifdef visborder
      Line dwin,(0-v.VisBorderX, 0-v.VisBorderY)- _
      (v.WinX+v.VisBorderX, v.WinY+v.VisBorderY),&H808080,b
#endif
      
      GfxPrint6 "Mouse: X="+Str$(p2wx(g.Mousex)/m)+"/"+Str$(p2wx(g.Mousex)/m), _
      0,64,&Hffffff,dwin
      s="...... X="+Str$(g.Mousex)+" Y="+Str$(g.Mousey)+" W="+Str$(g.Mousewh)+" B="+Str$(g.Mousebt)
      If g.Mousehold>g.Fps/click Then
        s=s+" *DRAG*"
      EndIf
      GfxPrint6 s,0,72,&Hffffff,dwin
      
      'Center cross
      Line dwin,(v.WinX/2,v.WinY/2-10)-(v.WinX/2,v.WinY/2-5),&Ha0a000
      Line dwin,(v.WinX/2,v.WinY/2+10)-(v.WinX/2,v.WinY/2+5),&Ha0a000
      Line dwin,(v.WinX/2-10,v.WinY/2)-(v.WinX/2-5,v.WinY/2),&Ha0a000
      Line dwin,(v.WinX/2+10,v.WinY/2)-(v.WinX/2+5,v.WinY/2),&Ha0a000
      
      If g.trksel<>0 Then
        s="Track........:"+w.Start(g.trksel)->tname+" "+ _
          Str$(w.Start(g.trksel)->length/m)+" Meter"
        GfxPrint6 s,0,80,&Hffffff,dwin
          
        s="Coor X="+Str$(w.Start(g.trksel)->x/m)+ _
          " Y="+Str$(w.Start(g.trksel)->y/m)+ _
          " Z="+Str$(w.Start(g.trksel)->z/m)+ _
          " <="+Str$(w.Start(g.trksel)->angle)
        GfxPrint6 s,0,88,&Hffffff,dwin

        s="Track size"+Str$(i)+ _
          " X:"+Str$(Int(w.Start(g.trksel)->dimension.minx/m))+ _
          "-"+Str$(Int(w.Start(g.trksel)->dimension.maxx/m))+ _
          " Y:"+Str$(Int(w.Start(g.trksel)->dimension.miny/m))+ _
          "-"+Str$(Int(w.Start(g.trksel)->dimension.maxy/m))
        GfxPrint6 s,0,96,&Hffffff,dwin
        GfxPrint6 "Track build..:"+Str$(w.Start(g.trksel)->build) _
          ,0,104,&Hffffff,dwin
      EndIf
      
      If g.ctrl<>0 Then
        If w.Train(i)<>0 Then
          GfxPrint6 "Current track segment" _
          ,0,112,&Hffffff,dwin
          s="Tr."+Str$(w.Train(i)->tr->TNum)+ _
            " N="+Str$(w.Train(i)->tr->tname)+ _
            " X="+Str$(Int(w.Train(i)->tr->x/m))+ _
            " Y="+Str$(Int(w.Train(i)->tr->y/m))+ _
            " L="+Str$(w.Train(i)->tr->length/m)+ _
            " <="+Str$(Int(w.Train(i)->tr->angle))
          GfxPrint6 s,0,120,&Hffffff,dwin
                
          s="Distance="+Str$(w.Train(i)->tr->distance/m)+ _
            " SigF="+w.Train(i)->tr->SigF+ _
            " SigR="+w.Train(i)->tr->SigR
          GfxPrint6 s,0,128,&Hffffff,dwin
          
          s="Turn="+Str$(w.Train(i)->tr->turn<>0)
          GfxPrint6 s,0,136,&Hffffff,dwin
        EndIf
      EndIf

      If g.ItemSel<>0 Then
        GfxPrint6 "Item........:"+Str$(g.ItemSel),0,144,&Hffffff,dwin
      EndIf
      
      For i=1 To 10
        If w.Train(i)<>0 Then
          If i=g.ctrl Then: s="* ": Else: s="- ": EndIf
          If i=v.cam Then: s=s+"w ": Else: s=s+"- ": EndIf
          s=s+"T:"+Str$(i)+" Sp="+Str$(Int(w.Train(i)->sp*2)/10)
          If IsTrainVisible(i) Then
            s=s+" */"
          Else
            s=s+" ./"
          EndIf
          If visrect(w.Train(i)->tr->mytrack->dimension.minx, _
             w.Train(i)->tr->mytrack->dimension.maxx, _
             w.Train(i)->tr->mytrack->dimension.miny, _
             w.Train(i)->tr->mytrack->dimension.maxy) Then
             s=s+"* "
           Else
             s=s+". "
           EndIf
          GfxPrint6 s,0,144+i*8,&Hffffff,dwin
        EndIf
      Next
    EndIf

    If v.Debug Then
      'Print function key code
      If Left$(ks,1)=Chr(255) Then
        GfxPrint6 "FnKey="+Mid$(ks,2,1)+Str$(ks[1]),v.WinX/2,8,&Hffffff,dwin
      Else
        GfxPrint6 "Key="+ks,v.WinX/2,8,&Hffffff,dwin
      EndIf
    EndIf

'    'display graphics on screen
'    Put(0,0),dwin,PSet

End Sub












'################################################
'## Map / Bitmap loader
'################################################

Function LoadBmp(index As Integer, n As String) As Integer

  Dim As Any Ptr map
  Dim As Integer mapw, maph, mx, my

  LoadBmp=1  'return code - error
  
  'create new memory element, if necessary
  If w.MapData(index)=NULL Then
    w.MapData(index)=new TBmp1023
  EndIf

  map = bmp_load(DataPath+n)
  w.MapData(index)->filename=n
  If map <> NULL Then
    If 0=ImageInfo (map, mapw, maph, , , , ) Then
      If mapw>1024 Then mapw=1024
      If maph>1024 Then maph=1024
      w.MapData(index)->w=mapw
      w.MapData(index)->h=maph
      
      For my=0 To maph-1
        For mx=0 To mapw-1
          w.MapData(index)->data(mx,my)=Point(mx, my, map)
        Next mx
      Next my
    
      ImageDestroy map
      LoadBmp=0   'return code - OK
    
    End If
  End If
End Function


Function NewMap(index As Integer, n As String, BmpIndex As Integer _
                , x As Integer, y As Integer _
                , scale As Integer _
                , ZoomMin As Integer, ZoomMax As Integer _
                ) As Integer

  NewMap=1  'return code - error

  If w.MapData(BmpIndex) <> NULL Then
  
    'create new memory element, if necessary
    If w.MapHdr(index)=NULL Then
      w.MapHdr(index)=new TBmp
    EndIf

    w.MapHdr(index)->x = x
    w.MapHdr(index)->y = y
    w.MapHdr(index)->scale = scale
    w.MapHdr(index)->ZoomMin = ZoomMin
    w.MapHdr(index)->ZoomMax = ZoomMax
    w.MapHdr(index)->BmpIndex = BmpIndex
    NewMap=0  'return code - OK
  EndIf
End Function


'fade rgb between two colors c1 and c2
'fade=0: return c1
'fade=255: return c2

Function FadeRGB(c1 As Integer, c2 As Integer, _
                 fade As Integer) As Integer
  Dim As Integer r, g, b, r1, g1, b1, r2, g2, b2
  
  If fade>255 Then fade=255
  
  r1=c1 Shr 16
  g1=c1 Shr 8 And 255
  b1=c1 And 255

  r2=c2 Shr 16
  g2=c2 Shr 8 And 255
  b2=c2 And 255
  
  r=(r1*(255-fade)+r2*fade) Shr 8
  g=(g1*(255-fade)+g2*fade) Shr 8
  b=(b1*(255-fade)+b2*fade) Shr 8
  
  FadeRGB=r Shl 16+g Shl 8+b
End Function


Sub CreateBmp(index As Integer, n As String, _
                BmpWidth As Integer, BmpHeight As Integer, _
                TLColor As Integer, _
                TRColor As Integer, _
                BLColor As Integer, _
                BRColor As Integer)

  Dim As Integer x, y, c1, c2, c3, c4, co

  
  'create new memory element, if necessary
  If w.MapData(index)=NULL Then
    w.MapData(index)=new TBmp1023
  EndIf

  w.MapData(index)->filename=n
  If BmpWidth>1024 Then BmpWidth=1024
  If BmpHeight>1024 Then BmpHeight=1024
  w.MapData(index)->w=BmpWidth
  w.MapData(index)->h=BmpHeight
  
  For y=0 To BmpHeight-1
    c1=FadeRGB(TLColor,BLColor,y*256/BmpHeight)
    c2=FadeRGB(TRColor,BRColor,y*256/BmpHeight)
    For x=0 To BmpWidth-1
      w.MapData(index)->data(x,y)=FadeRGB(c1,c2,x*256/BmpWidth)
    Next x
  Next y

End Sub



'################################################
'## trains.ini init-file
'################################################


Dim Shared As String ini_s
Dim Shared As Integer ini_f, ini_lnum

' read a string from ini-file, count line number

Function IniRead As String
  Dim As String s

  Line Input #ini_f, s
  s=trim(s)
  'Input #ini_f, s
  ini_lnum+=1
'  Print "processing line "+str(ini_lnum)+": "+s
  IniRead=s
End Function


' read a number from ini-file, count line number
' allow underscore "_" as a separator
' 10_000 = 10000

Function IniReadNum As Integer
  Dim As Integer i, er
  Dim As String s

  Line Input #ini_f, s
  s=trim(s)
  ini_lnum+=1
  
  'eliminate "_"
  For i=1 To Len(s)
    If mid(s,i,1)="_" Then
      s=left(s,i-1)+right(s, Len(s)-i)
    EndIf
  Next
  
  'check for valid characters
  'cut comment behind number
  For i=1 To Len(s)
    If InStr("-0123456789xabcdefABCDEF",mid(s,i,1))=0 Then
      If i=1 Then
        er=1            ' error
      Else
        s=left(s,i-1)   ' cut characters behind number
        Exit For
      EndIf
    EndIf
  Next
  
  'replace "0x" by "&H"
  If left(s,2)="0x" Then
    s="&H"+right(s,Len(s)-2)
  EndIf

  'check for empty line
  If s="" Then er=1
  
  If er Then
    Print "*** Error"
    Print "*** invalid number format in line "+str(ini_lnum)
    Print s
    Sleep
    End
  EndIf
  
  i=Val(s)
  IniReadNum=i
End Function


Sub ExecIniFile

  Dim As Integer er

  Dim As String s, s1, s2
  Dim As Integer p1, p2, p3, p4, p5, p6, p7, p8
  
  ini_f=FreeFile
  
  ini_lnum=0
  er=0
  If 0=Open(DataPath+CInitFile For Input As #ini_f) Then
    Do
      s=IniRead
'      Print right("   "+str(ini_lnum),5)+" ["+s+"]"

      'parse
      If lcase(s)="loadbmp" Then
        'load bitmap
        Print "processing line "+str(ini_lnum)+": "+s
        p1=IniReadNum 'index
        s1=IniRead    'filename
        Print "Exec LoadBmp("+str(p1)+","+s1+")"
        If LoadBmp(p1, s1) Then
          er+=1
          Print "*** Error"
          Print "*** can't load "+s1
        EndIf


      ElseIf lcase(s)="colorbmp" Then
        'create bitmap
        Print "processing line "+str(ini_lnum)+": "+s
        p1=IniReadNum 'index
        s1=IniRead    'filename
        p2=IniReadNum 'size x
        p3=IniReadNum 'size y
        p4=IniReadNum 'color
        p5=IniReadNum 'color
        p6=IniReadNum 'color
        p7=IniReadNum 'color
        Print "Exec ColorBmp("+str(p1)+","+s1+","+str(p2)+","+str(p3)+","+str(p4)+","+str(p5)+","+str(p6)+","+str(p7)+")"
        CreateBmp(p1,s1,p2,p3,p4,p5,p6,p7)
  

      ElseIf lcase(s)="newmap" Then
        'create map
        Print "processing line "+str(ini_lnum)+": "+s
        p1=IniReadNum 'index
        s1=IniRead    'filename
        p2=IniReadNum 'bmp index
        p3=IniReadNum 'pos x
        p4=IniReadNum 'pos y
        p5=IniReadNum 'scale
        p6=IniReadNum 'zoom min
        p7=IniReadNum 'zoom max
        Print "Exec NewMap("+str(p1)+","+s1+","+str(p2)+","+str(p3)+","+str(p4)+","+str(p5)+","+str(p6)+","+str(p7)+")"
        NewMap(p1,s1,p2,p3,p4,p5,p6,p7)


      ElseIf lcase(s)="bitmaptime" Then
        'time limit (msec) for drawing bitmaps
        Print "processing line "+str(ini_lnum)+": "+s
        p1=IniReadNum 'time
        Print "Set Bitmap time limit("+str(p1)+")"
        MapPerformance=p1


      ElseIf lcase(s)="zoomlimit" Then
        'time limit (msec) for drawing bitmaps
        Print "processing line "+str(ini_lnum)+": "+s
        p1=IniReadNum 'zoom min
        p2=IniReadNum 'zoom max
        If p1<10 Then p1=10
        If p1>10000 Then p1=10000
        If p2<1000 Then p2=1000
        If p2>1000000 Then p2=1000000
        If p2<p1 Then p2=p1*10
        Print "Set zoom limit("+str(p1)+","+str(p2)+")"
        ZoomMinLevel=p1
        ZoomMaxLevel=p2


      ElseIf lcase(s)="groundcolor" Then
        'default background color
        Print "processing line "+str(ini_lnum)+": "+s
        p1=IniReadNum 'color
        Print "Set GroundColor("+str(p1)+")"
        GroundColor=p1


      ElseIf left(s,1)="#" Then
        'ignore comments


      ElseIf s="" Then
        'ignore blank lines


      Else
        Print "Error in trainini.txt, line "+str(ini_lnum)
        Print " "+s
        er+=1
      EndIf
      
    Loop Until EOF(ini_f) orelse er
    If er Then
      Sleep
      End
    EndIf
    
  Else
    Print
    Print "Error: can't open ini file"
    Print DataPath+CInitFile
    Print
    Print "Proceed with default values"
    Print " <press Enter>"
    Sleep
    Cls
  EndIf
  
End Sub



'################################################
'## trainmod.txt - vector graphics items
'################################################


''parse: separate and return left word from string
'
'Function SplitL(s As String) As String
'  Dim As Integer p
'  Dim As String result
'  
''  Print "SplitL"
'
'  result=trim(s)
''  Print "trim: "+result
'
'  p=InStr(result," ")
'  If p=0 Then p=InStr(result,",")
''  Print "separator: "+str(p)
'
'  If p<>0 Then
'    result=left(result,p-1)
'  EndIf
''  Print "LSplit result: ["+result+"]"
'
'  SplitL=result  
'End Function
'
'
''parse: separate left word from string, return rest
'
'Function SplitR(s As String) As String
'  Dim As Integer p
'  Dim As String result
'  
'  result=trim(s)
'  p=InStr(result," ")
'  If p=0 Then p=InStr(result,",")
'  If p<>0 Then
'    result=right(result,Len(result)-p)
'  Else
'    result=""
'  EndIf
''  Print "RSplit result: ["+result+"]"
'  SplitR=result
'End Function


'Sub LoadModel
' 
'  Dim As Integer er
'
'  Dim As String s, s1, s2
'  Dim As Integer p1, p2, p3, p4, p5, p6, p7, p8
' 
'  Print 
'  Print "LoadModel"
'  Print 
'  
'  ini_f=FreeFile
'  
'  ini_lnum=0
'  er=0
'  If 0=Open(DataPath+CModelFile For Input As #ini_f) Then
'    Do
'      s=IniRead
''      s1=SplitL(s)
''      s2=SplitR(s)
''
''      Print right("   "+str(ini_lnum),5)+" ["+s1+"]  ["+s2+"]"
''      
''
''      'parse
''      If lcase(s1)="item" Then
''        Print "New Item"
''        Do
''          s=IniRead
''          s1=SplitL(s)
''          s2=SplitR(s)
''          Print right("   "+str(ini_lnum),5)+" ["+s1+"]  ["+s2+"]"
''          
''        Loop Until lcase(s1)="enditem" OrElse EOF(ini_f)
''
''      ElseIf left(s,1)="#" Then
''        'ignore comments
''      ElseIf s="" Then
''        'ignore blank lines
''      Else
''        Print "Error in trainini.txt, line "+str(ini_lnum)
''        Print " "+s
''        er+=1
''      EndIf
''      
''      Print
''      Sleep
'
'    Loop Until EOF(ini_f) orelse er
'    If er Then
'      Sleep
'      End
'    EndIf
'    
'  Else
'    Print
'    Print "Error: Can't open Model File"
'    Print DataPath+CModelFile
'    Print
'    Print "Proceed with default values"
'    Sleep
'  EndIf
'  
'End Sub
'

'Const CItemFile="trainmod.txt" ' vector models / items

''Building: House
'i=Buildings
'w.model(i)=new TModel
'w.model(i)->mName="House"
'w.model(i)->mBuild= _
'   iAddZoomOut(255) _
'  +iAddColor(&H800000) _
'  +iAddLine(0,-125,0,125) _
'  +iAddZoomIn(255) _
'  +iAddColor(&H801515) _
'  +iAddFBox(-50,-125,50,125) _
'  +iAddZoomIn(80) _
'  +iAddColor(1) _
'  +iAddLine(-50,-125,0,-100) _
'  +iAddLine(0,-100,50,-125) _
'  +iAddLine(-50,125,0,100) _
'  +iAddLine(0,100,50,125) _
'  +iAddLine(0,-100,0,100) _
'  +iAddZoomIn(10) _
'  +iAddColor(&H808000) _
'  +iAddFCircle(25,0,10)



'################################################
'## Save Data File
'################################################



Function fdec(n As Integer, comment As String) As String
  fdec="  "+left(str(n)+"            ",12)+"# "+comment
End Function

Function fhex(n As Integer, comment As String) As String
  fhex="  0x"+hex(n,6)+"    "+"# "+comment
End Function

Sub SaveDataFile

  Dim As Integer er, df

  Dim As String s
  Dim As Integer i
  Dim As PTrack pt
  
  df=FreeFile
  er=Open(DataPath+CDataFile For Output As #df)
  If er=0 Then
    Print #df, "####################################"
    Print #df, "#"
    Print #df, "# train simulator data file"
    Print #df, "#"
    Print #df, "####################################"
    Print #df,
    Print #df, "####################################"
    Print #df, "#"
    Print #df, "# tracks"
    Print #df, "#"
    Print #df, "# angle:"
    Print #df, "#   0 = east,  128 = south"
    Print #df, "# 256 = west,  384 = north"
    Print #df, "#"
    Print #df, "####################################"
    Print #df,
    Print #df, "version"
    Print #df, "  "+FileVersion
    Print #df,

    For i=0 To MaxTracks
      If w.Start(i)<>NULL Then
        Print #df, "# Track "+str(i)+": "+w.Start(i)->tName
        Print #df, "track"
        Print #df, "  "+w.Start(i)->tName
        Print #df, fdec(w.Start(i)->x, "X")
        Print #df, fdec(w.Start(i)->y, "Y")
        Print #df, fdec(w.Start(i)->z, "Z")
        Print #df, fdec(w.Start(i)->angle, "Angle (0-511)")
        
        'run through track segments and rebuild track string
        pt=w.Start(i)->start
        Do
          s=s+pt->tname
          'check for signals
          If (pt->SigF<>"") OrElse (pt->SigR<>"") Then
            s=s+"("+pt->SigF+","+pt->SigR+")"
          EndIf
          pt=pt->pn
        Loop Until pt=w.Start(i)->last
        s=s+pt->tname
        
        'check if tack is closed
        If w.Start(i)->start=w.Start(i)->last->pf Then
          s=s+"c"
        EndIf
        Do
          Print #df, "  "+left(s,32)
          If Len(s)>32 Then
            s=right(s,Len(s)-32)
          Else
            s=""
          EndIf
        Loop Until s=""
        Print #df, "trackend"
        
        Print #df,
      EndIf
    Next i


    Print #df,
    Print #df, "####################################"
    Print #df, "#"
    Print #df, "# Turnouts"
    Print #df, "#"
    Print #df, "####################################"
    Print #df,

    For i=0 To MaxTurnouts
      If w.Turnouts(i)<>NULL Then
        Print #df, "# Turnout "+str(i)
        Print #df, "Turnout"
        Print #df, "  "+w.Turnouts(i)->pr1->mytrack->tName
        Print #df, fdec(w.Turnouts(i)->pr1->tNum,"Track Segment")
        Print #df, "  "+w.Turnouts(i)->pr2->mytrack->tName
        Print #df, fdec(w.Turnouts(i)->pr2->tNum,"Track Segment")
        Print #df, fdec(w.Turnouts(i)->Turn,"Turn State")
        Print #df,
      EndIf
    Next i


    Print #df,
    Print #df, "####################################"
    Print #df, "#"
    Print #df, "# Trains"
    Print #df, "#"
    Print #df, "####################################"
    Print #df,

    For i=0 To MaxTrains
      If w.Train(i)<>NULL Then
        Print #df, "# Train "+str(i)
        Print #df, "Train"
        Print #df, "  "+w.model(w.Train(i)->pic)->mName
        Print #df, "  "+w.Train(i)->tr->mytrack->tName
        Print #df, fdec(w.Train(i)->waggons,"Size")
        Print #df, fdec(w.Train(i)->tr->tNum,"Track Segment")
        Print #df, fdec(w.Train(i)->ps,"Position")
        Print #df, fdec(w.Train(i)->sp,"Speed")
        Print #df, fdec(w.Train(i)->control,"Control")

        Print #df,
      EndIf
    Next i


    Print #df,
    Print #df,
    Print #df, "####################################"
    Print #df, "#"
    Print #df, "# placed vector graphics objects"
    Print #df, "#"
    Print #df, "####################################"
    Print #df,

    For i=0 To MaxItems
      If w.Items(i)<>NULL Then
        Print #df, "# Item "+str(i)
        Print #df, "place"
        Print #df, "  "+w.model(w.Items(i)->build)->mName
        Print #df, fdec(w.Items(i)->a.x, "AX")
        Print #df, fdec(w.Items(i)->a.y, "AY")
        Print #df, fdec(w.Items(i)->a.z, "AZ")
        Print #df, fdec(w.Items(i)->b.x, "BX")
        Print #df, fdec(w.Items(i)->b.y, "BY")
        Print #df, fdec(w.Items(i)->b.z, "BZ")
        Print #df, fhex(w.Items(i)->col, "Color")
        Print #df, fdec(w.Items(i)->ScaleType, "ScaleType")
        Print #df,
      EndIf
    Next i

    Print #df,
    Print #df,
    Print #df, "####################################"
    Print #df, "#"
    Print #df, "# global settings"
    Print #df, "#"
    Print #df, "####################################"
    Print #df,

    Print #df, "view"
    Print #df, fdec(v.Cam, "Cam")
    Print #df, fdec(v.MapActive, "MapActive")
    Print #df, fdec(v.LandMapActive, "LandMapActive")
    Print #df, fdec(v.Debug, "Debug")
    Print #df, fdec(v.GridOn, "GridOn")
    Print #df, fdec(v.Scale, "Scale")
    Print #df, fdec(v.OffX, "OffX")
    Print #df, fdec(v.OffY, "OffY")
    Print #df, fdec(g.Ctrl, "Ctrl")
    Print #df, fdec(helpman, "HelpMan")
    Print #df, fdec(OhdFps, "OhdFps")

    Close (df)
  Else
    Cls
    Print "Error - Can't save file "+DataPath+CDataFile
    Sleep
    Cls
  EndIf
End Sub


Sub LoadDataFile(n As String)
  Dim As Integer er, df

  Dim As String s, s1, s2, MName, MBuild
  Dim As Integer i, j, n1, n2, n3, n4, n5, n6, n7, n8
  
  ini_f=FreeFile
  ini_lnum=0
  er=0
  
'  Cls
  
  LogFile("")
  LogFile("LoadDataFile ("+n+")")

  er=Open(DataPath+n For Input As #ini_f)
  If er=0 Then
    
    Do
      s=IniRead

      '#
      '##########################################
      '# load tracks
      '##########################################
      '#
      If lcase(s)="version" Then

        S1=IniRead
        If S1<>FileVersion Then
          MessageBox("Incompatible File Version "+S1)
        EndIf
        
      '#
      '##########################################
      '# load tracks
      '##########################################
      '#
      ElseIf lcase(s)="track" Then
        InfoBox("Load Track "+MName)
        MName=IniRead
        LogFile("")
        LogFile("Load Track ["+MName+"]")
        n1=InIReadNum
        n2=InIReadNum
        n3=InIReadNum
        n4=InIReadNum
        s=IniRead
        MBuild=""
        Do While lcase(s)<>"trackend"
          MBuild=MBuild+s
          s=IniRead
        Loop
        ' find next free track start index
        i=1
        Do While w.Start(i)<>NULL
          'check, if track with same name exist. if yes, abort with error
          If w.Start(i)->TName=MName Then
            er+=1
            Message("Error while loading - Track with same name exist: "+MName)
            Exit Do
          EndIf
          i+=1
        Loop
        If er=0 Then
          w.Start(i)=BuildTrack(MName, MBuild, n1, n2, n3, n4)
          LogFile("Load Track ["+MName+"] done.")
        EndIf
        
      '#
      '##########################################
      '# load turnouts
      '##########################################
      '#
      ElseIf lcase(s)="turnout" Then
        InfoBox("Add Turnout")
        s1=InIRead          'Track 1 Name
        n1=NumOfTrack(s1)
        n2=InIReadNum       'Track 1 Segment number
        s2=InIRead          'Track 2 Name
        n3=NumOfTrack(s2)
        n4=InIReadNum       'Track 2 Segment number
        n5=InIReadNum       'Turn State

        If (n1>0) AndAlso (n3>0) Then
          i=InstallTurnout(w.Start(n1), n2-1, w.Start(n3), n4-1)
          If n5=2 Then
            SwitchTurnout(w.Turnouts(i))
          EndIf
        EndIf
        LogFile("Load Turnout ["+s1+", "+str(n1)+", "+str(n2)+", "+_
                s2+", "+str(n3)+", "+str(n4)+"] done.")

      '#
      '##########################################
      '# load trains
      '##########################################
      '#
      ElseIf lcase(s)="train" Then
        MName=IniRead
        InfoBox("Load Train "+MName)
        s=IniRead
        n1=NumOfTrack(s)
        n2=InIReadNum 'size
        n3=InIReadNum 'track segment
        n4=InIReadNum 'position
        n5=InIReadNum 'speed
        n6=InIReadNum 'control
                
        'set j to train model index (train picture)
        i=1
        For j=1 To MaxModels
          If MName=w.model(j)->mName Then
            i=j
            Exit For
          EndIf
        Next j

        i=NewTrain(n1, n5, i, n2)
        
        'Place Train to saved Track Segment and Position
        'Set AutoPilot Controls
        If (i>0) AndAlso (i<MaxTrains) Then          
          Do While w.Train(i)->tr->TNum <> n3
            w.Train(i)->tr=w.Train(i)->tr->pn
            If w.Train(i)->tr = w.Train(i)->tr->MyTrack->last Then
              Exit Do
            EndIf
          Loop
          w.Train(i)->ps=n4
          w.Train(i)->control=n6
        EndIf
        LogFile("Load Train ["+MName+"] done.")
        
      '#
      '##########################################
      '# load items
      '##########################################
      '#
      ElseIf lcase(s)="place" Then
        MName=InIRead          'model name
        InfoBox("Load Item "+MName)
        n1=InIReadNum       'AX
        n2=InIReadNum       'AY
        n3=InIReadNum       'AZ
        n4=InIReadNum       'BX
        n5=InIReadNum       'BY
        n6=InIReadNum       'BZ
        n7=InIReadNum       'Color
        n8=InIReadNum       'ScaleType

        'Place Item in World
        'set i to next free index position
        i=1
        Do While (w.Items(i)<>0)
          i+=1
        Loop
        If i<MaxItems _
        AndAlso NumOfModel(MName)<>0 Then
          CreateItem(i, n1, n2, n4, n5, NumOfModel(MName), n7, n8)
        EndIf
        LogFile("Load and placed Item ["+MName+"] done.")
        
      '#
      '##########################################
      '# Global Settings
      '##########################################
      '#
      ElseIf lcase(s)="view" Then
        InfoBox("Load Global View Setup")
        v.Cam=InIReadNum
        'index may change on load - avoid invalid pointer access
        If w.Train(v.Cam)=NULL Then
          v.Cam=0
          LogFile("")
          LogFile("Error on Loading Global Settings")
          LogFile(" - Invalid Index v.Cam")
          LogFile(" - Check File "+DataPath+n)
        EndIf
        v.MapActive=InIReadNum
        v.LandMapActive=InIReadNum
        v.Debug=InIReadNum
        v.GridOn=InIReadNum
        v.Scale=InIReadNum
        v.OffX=InIReadNum
        v.OffY=InIReadNum
        g.Ctrl=InIReadNum
        helpman=InIReadNum
        OhdFps=InIReadNum

        'index may change on load - avoid invalid pointer access
        If w.Train(g.Ctrl)=NULL Then
          g.Ctrl=0
          LogFile("")
          LogFile("Error on Loading Global Settings")
          LogFile(" - Invalid Index g.Ctrl")
          LogFile(" - Check File "+DataPath+n)
        EndIf
      EndIf
        
    Loop Until EOF(ini_f) OrElse er    
    Close (df)
  Else
    Cls
    Print "Error - Can't open file "+DataPath+n
    Sleep
    Cls
  EndIf
  g.EditTrkPtrA=0
End Sub




'################################################
'## Load / Save Vector Model
'################################################


' save all models by name and build string (hex)
' print line break after every 16 hex bytes
Sub SaveModelFile

  Dim As Integer er, df

  Dim As String s
  Dim As Integer i, j, cnt
  
  df=FreeFile
  cnt=0
  
  er=Open(DataPath+CModelFile For Output As #df)
  If er=0 Then
    Print #df, "####################################"
    Print #df, "#"
    Print #df, "# train simulator vector model file"
    Print #df, "#"
    Print #df, "####################################"
    Print #df,

    For i=0 To MaxModels
      If w.Model(i)<>NULL AndAlso w.Model(i)->mBuild<>"" Then
        s=w.Model(i)->mBuild
        Print #df,
        Print #df, "model"
        Print #df, "  "+w.Model(i)->mName
        For j=1 To Len(s)
          If (j And 15)=1 Then
            Print #df,"  ";
          EndIf
          Print #df,hex(Asc(mid(s,j,1)),2);
          If (j And 15)=0 AndAlso j<Len(s) Then
            Print #df,
          EndIf
        Next j
        Print #df,
        Print #df, "endmodel"
      EndIf
    Next i

    Close (df)
  Else
    Cls
    Print "Error - Can't save file "+DataPath+CModelFile
    Sleep
    Cls
  EndIf
End Sub


' load models from file
' models with a name that already exist
' will be replaced by the model from file


Sub LoadModelFile(n As String)

  Dim As Integer er, df

  Dim As String s, MName, MBuild
  Dim As Integer i, mi, cnt
  
  ini_f=FreeFile
  ini_lnum=0
  er=0
  
  Cls
  
  er=Open(DataPath+n For Input As #ini_f)
  If er=0 Then

    Do
      s=IniRead
      If lcase(s)="model" Then
        Print right("    "+str(ini_lnum),5)+" "+s
        MName=IniRead
        Print right("    "+str(ini_lnum),5)+" "+MName
        
        'check if model with same name exist
        mi=-1                   'model index
        For i=0 To MaxModels
          If (w.Model(i)<>NULL) AndAlso _
          (w.Model(i)->mName = MName) Then
            mi=i
          EndIf
        Next i
        
        If mi=-1 Then
          Print "Model is new"
          'set mi to next free position
          mi=-1
          Do
            mi+=1
          Loop Until w.Model(mi)=NULL
          w.Model(mi) = new TModel
        Else
          Print "Model already exist (index="+str(mi)+")"
        EndIf
        
        'load data into model
        w.Model(mi)->mName = MName
        w.Model(mi)->mBuild = ""
        Do
          s=trim(IniRead)
          If s<>"endmodel" Then
            For i=1 To Len(s)/2
              w.Model(mi)->mBuild=w.Model(mi)->mBuild+_
              chr(Val("&H"+mid(s,i*2-1,2)))
            Next i
          EndIf
        Loop Until EOF(ini_f) OrElse (lcase(s)="endmodel")

        Print
      EndIf
    Loop Until EOF(ini_f)

'    Sleep
    Cls

    Close (df)
  Else
    Cls
    Print "Error - Can't open file "+DataPath+n
    Sleep
    Cls
  EndIf
End Sub







'################################################
'## Main (Init)
'################################################

screenres WinXMax,WinYMax,24

DataPath=CDataPath   'ini-file, bitmaps ...
MapPerformance=CMapPerformance

win480=imagecreate(480-2,480-2)
win160=imagecreate(160-2,160-2)

View1.PosX=0+1
View1.PosY=0+1
View1.WinX=480-2
View1.WinY=480-2
View1.Scale=1500
View1.VisBorderX=-View1.WinX/10
View1.VisBorderY=-View1.WinY/10
View1.cam=0
View1.MapActive=0
View1.Debug=0
View1.Gridon=0

View2.PosX=480+1
View2.PosY=0+1
View2.WinX=160-2
View2.WinY=160-2
View2.Scale=12500
View2.VisBorderX=-View2.WinX/10
View2.VisBorderY=-View2.WinY/10
View2.cam=0
View2.MapActive=0
View2.Debug=0
View2.Gridon=0
View2.OffX=View2.WinX/2-1001000*m/View2.Scale
View2.OffY=View2.WinY/2-1000500*m/View2.Scale

View3=View2
View3.PosX=480+1
View3.PosY=160+1
View3.Scale=800
View3.cam=1

'v.OldCam=0

ScanCam=0

Color &Heeeeee,&H204020
Cls


'create new log file

i=FreeFile
If 0=Open (CDataPath+CLogFile For Output As #i) Then
  Print #i, "###"
  Print #i, "### TrainSim Logfile ###"
  Print #i, "###"
  Print #i,
  Close #i
Else
  Print "Error, can't create logfile "+CDataPath+CLogFile
  Sleep
EndIf


'######################################################
'### read ronfiguration (trainini.txt)
'######################################################


Print
Print "Processing ini-file"
Print

ExecIniFile
Sleep 1000


Cls

ofx=1000*1000*m
ofy=1000*1000*m

Print "<<< 1 >>>"

#ifdef mapon


'Build map

'replace "Allocate" by "New" and "DeAllocate" by "Delete" (hint from fxm / FreeBASIC forum)
'w.map=CAllocate(sizeof(TMapR))
w.map=New TMapR


map1=w.map
For i=0 To WorldX*MapRes-1
  For j=0 To WorldY*MapRes-1
    map1->x1=(ofx-WorldX/2*1000*m)+ i*1000/MapRes*m
    map1->y1=(ofy-WorldY/2*1000*m)+j*1000/MapRes*m
    map1->x2=(ofx-WorldX/2*1000*m)+(i*1000/MapRes+1000/MapRes)*m
    map1->y2=(ofy-WorldY/2*1000*m)+(j*1000/MapRes+1000/MapRes)*m
    map1->Color=(30+Int(Rnd()*10))*&H10000 _
               +(60+Int(Rnd()*50))*&H100 _
               +(30+Int(Rnd()*20))

    'replace "Allocate" by "New" and "DeAllocate" by "Delete" (hint from fxm / FreeBASIC forum)
    'map1->pnext=CAllocate(sizeof(TMapR))
    map1->pnext=New TMapR

    map1=map1->pnext
  Next
Next
#endif

'bload "Train.bmp",@bmp1(0)

''#####################################
'ScreenSet p2,p2
'Print "Build Tracks"
'Sleep
''#####################################
  
'Build tracks

Print "<<< 2 >>>"


'i=1
'w.Start(i)=BuildTrack("Westlands","f l2*32 f*8 l2*32 f*7c", ofx+1000*m, ofy+700*m, 0, 256)
'
'i+=1
'w.Start(i)=BuildTrack("Small town","f l1*32 f*8 l1*32 fsfc", ofx+1000*m, ofy+708*m, 0, 256)
'
'InstallTurnout(w.Start(1),0,w.Start(2),0)
'InstallTurnout(w.Start(1),74,w.Start(2),74)
'
'
'i+=1
'w.Start(i)=BuildTrack("Coastline", _
'  "f*66 r*16 f*33 r*16 f*66 r*16 f*33 r*16c", _
'  ofx+200*m, ofy+50*m, 0, 0)
'
'i+=1
'w.Start(i)=BuildTrack("Stop 1","e f*30 s f*10 e", _
'  ofx+300*m, ofy+60*m, 0, 0)
'
'i+=1
'w.Start(i)=BuildTrack("Stop 2","e f*26 s f*10 e", _
'  ofx+400*m, ofy+70*m, 0, 0)
'
'InstallTurnout(w.Start(3),4,w.Start(4),1)
'InstallTurnout(w.Start(4),5,w.Start(5),1)


















i=1
w.Start(i)=BuildTrack("Westlands","f L*16 f*8 L*16 f*7c", ofx+250*m, ofy+100*m, 0, 256)

i+=1
w.Start(i)=BuildTrack("Small town","f l1*32 f*8 l1*32 fsfc", ofx+250*m, ofy+108*m, 0, 256)

i+=1
w.Start(i)=BuildTrack("Cross country", _
  "f*4 L*4 f*9 R3*18 f*4 L*2 f*11 R*8 f R*7 R3*4 c", _
  ofx+773*m, ofy+131*m, 0, 256/4)

i+=1
w.Start(i)=BuildTrack("East-8","f*3 f5 s R*8 R6 R*15 f6 f*8 f5 L*24 f c", _
  ofx+1503*m, ofy+397*m, 0, -256/4)

i+=1
w.Start(i)=BuildTrack("Big western", _
  "fffff(slow,) f*9 s f*8 L(,slow) L L*6 ffff"+_
  " L(slow,) L*7 ff s f*6 LLLL(,slow) L*4 f*10 R*8 ff R*8 ff"+ _
  " RRRR ff RRRR ff R*8 fff*10 f2 R(slow,)RRRRRR R3 ff s f"+ _
  " R*6 R5 R5 f(,slow) fff RRR5RRR f RR f c", _
  ofx+287*m, ofy+742*m, 0, 0)

i+=1
w.Start(i)=BuildTrack("Eastcoast", _
  "f*10 L*8 f*9 f5 L*8 ff L*8 f5 f*24 R*5 f*6 fffff f*6 R*8 f*4 R*4 f1 R*4"+ _
  "f*22 L*29 fffff c", _
  ofx+1385*m, ofy+815*m, 0, 256/4-256/16)

i+=1
w.Start(i)=BuildTrack("South City", _
  "f*7 R*16 f s f R*16 c", _
  ofx+1104*m, ofy+1105*m, 0, 256)

i+=1
w.Start(i)=BuildTrack("Coastline", _
  "fffff f(speed:150,) f*60 R*8"+ _
  " f*33 R*8"+ _
  " f*46 f(slow,) f*11 f*8 R*8"+ _
  " f(speed:150,)f f(,slow) f*30 R*8c", _
  ofx+200*m, ofy+50*m, 0, 0)

i+=1
w.Start(i)=BuildTrack("Stop 1","e f*30 s f*10 f(crash,) e", _
  ofx+300*m, ofy+60*m, 0, 0)

i+=1
w.Start(i)=BuildTrack("Stop 2","e f*26 s f*10 f(crash,) e", _
  ofx+400*m, ofy+70*m, 0, 0)

''manually build track
'i+=1
'w.Start(i)=NewTrack("Test "+Str$(i), ofx+200*m, ofy+80*m, 0, 0)
'AddTrack(w.Start(i),"e")
'AddTrack(w.Start(i),"f")
'AddTrack(w.Start(i),"f")
'AddTrack(w.Start(i),"f")
'AddTrack(w.Start(i),"f")
'AddTrack(w.Start(i),"f")
'AddTrack(w.Start(i),"f")
'AddTrack(w.Start(i),"f")
'AddTrack(w.Start(i),"f")
'AddTrack(w.Start(i),"e")
'ActivateTrack(w.Start(i))


InstallTurnout(w.Start(1),0,w.Start(2),0)
InstallTurnout(w.Start(1),41,w.Start(2),73)
InstallTurnout(w.Start(1),32,w.Start(3),60)
InstallTurnout(w.Start(3),24,w.Start(4),50)

InstallTurnout(w.Start(3),42,w.Start(5),43)
InstallTurnout(w.Start(3),50,w.Start(5),47)

InstallTurnout(w.Start(4),24,w.Start(6),40)
InstallTurnout(w.Start(5),22,w.Start(6),120)

InstallTurnout(w.Start(5),131,w.Start(8),172)
InstallTurnout(w.Start(5),134,w.Start(8),179)

InstallTurnout(w.Start(6),85,w.Start(7),6)
InstallTurnout(w.Start(6),78,w.Start(7),41)

InstallTurnout(w.Start(8),4,w.Start(9),1)
InstallTurnout(w.Start(9),5,w.Start(10),1)



Print "<<< 3 >>>"

'center view to track 1

Const WatchTrain=5

v=View1
ScreenCenter((w.Start(WatchTrain)->dimension.minx+ _
              w.Start(WatchTrain)->dimension.maxx)/2, _
             (w.Start(WatchTrain)->dimension.miny+ _
              w.Start(WatchTrain)->dimension.maxy)/2)

'ScreenCenter((w.Start(1)->dimension.minx+w.Start(1)->dimension.maxx)/2, _
'             (w.Start(1)->dimension.miny+w.Start(1)->dimension.maxy)/2)

View1=v

'v=View2
'ScreenCenter((w.Start(5)->dimension.minx+w.Start(5)->dimension.maxx)/2, _
'             (w.Start(5)->dimension.miny+w.Start(5)->dimension.maxy)/2)
'View2=v

v=View1

''#####################################
'ScreenSet p2,p2
'Print "Build Trains"
'Sleep
''#####################################

'build trains

'replace "Allocate" by "New" and "DeAllocate" by "Delete" (hint from fxm / FreeBASIC forum)
'waggon=CAllocate(sizeof(TTrain))
'waggon=New TTrain




'create up to 8 trains
For i=1 To 8
  If w.Start(i)<>0 Then
    'Track Index, Speed, Picture, Length
    NewTrain(i, (30+Rnd()*70)*5, Locomotives+(i Mod 2), 2+i)
  EndIf
Next i

'activate train 8 assist diver
w.Train(8)->control=auto 'none



''create up to 8 trains
'For i=1 To 8
'  If w.Start(i)<>0 Then
'
'    'replace "Allocate" by "New" and "DeAllocate" by "Delete" (hint from fxm / FreeBASIC forum)
'    'w.Train(i)=CAllocate(sizeof(TTrain))
'    w.Train(i)=New TTrain
'
'    w.Train(i)->sp=(30+Rnd()*70)*5
'    w.Train(i)->tr=w.Start(i)->start->pn
'    w.Train(i)->ps=0
'    w.Train(i)->control=none 'auto
'    w.Train(i)->waggons=w.Train(i)->tr->mytrack->last->tnum/5
'    w.Train(i)->pic=Locomotives+(i Mod 2)
'  EndIf
'Next i



Print "<<< 4 >>>"



'Build Items for drwaing (Train, House)


'forest
i=Vegetation
w.model(i)=new TModel
w.model(i)->mName="Forest"
w.model(i)->mBuild=iAddColor(&H008040)
For j=1 To 10
  w.model(i)->mBuild=w.model(i)->mBuild+iAddFCircle(20+Rnd*210-125,25+Rnd*200-125,5+Rnd*10)
Next
w.model(i)->mBuild=w.model(i)->mBuild+iAddColor(&H00a030)
For j=1 To 10
  w.model(i)->mBuild=w.model(i)->mBuild+iAddFCircle(20+Rnd*210-125,25+Rnd*200-125,5+Rnd*10)
Next


'Building: House
i=Buildings
w.model(i)=new TModel
w.model(i)->mName="House"
w.model(i)->mBuild= _
   iAddZoomOut(255) _
  +iAddColor(&H800000) _
  +iAddLine(0,-125,0,125) _
  +iAddZoomIn(255) _
  +iAddColor(&H801515) _
  +iAddFBox(-50,-125,50,125) _
  +iAddZoomIn(80) _
  +iAddColor(1) _
  +iAddLine(-50,-125,0,-100) _
  +iAddLine(0,-100,50,-125) _
  +iAddLine(-50,125,0,100) _
  +iAddLine(0,100,50,125) _
  +iAddLine(0,-100,0,100) _
  +iAddZoomIn(10) _
  +iAddColor(&H808000) _
  +iAddFCircle(25,0,10)

'Building: Station
i+=1
w.model(i)=new TModel
w.model(i)->mName="Rail Station"
w.model(i)->mBuild= _
   iAddZoomOut(255) _
  +iAddColor(&H800000) _
  +iAddLine(0,-50,0,50) _
  +iAddZoomIn(255) _
  +iAddColor(&H404030) _
  +iAddFBox(-50,-125,50,125) _
  +iAddColor(&H801515) _
  +iAddFBox(-20,-50,20,50) _
  +iAddZoomIn(80) _
  +iAddColor(1) _
  +iAddLine(-20,-50,0,-40) _
  +iAddLine(0,-40,20,-50) _
  +iAddLine(-20,50,0,40) _
  +iAddLine(0,40,20,50) _
  +iAddLine(0,-40,0,40)      

i=Locomotives
w.model(i)=new TModel
w.model(i)->mName="Red Train"
w.model(i)->mBuild= _
   iVehicle _
  +iAddZoomOut(200) _
  +iAddColor(1) _
  +iAddLine(-20,-70,20,70) _
  +iAddLine(20,-70,-20,70) _
  +iAddZoomIn(200) _
  +iAddColor(&H802020) _
  +iAddFBox(-20,-65,20,65) _
  +iAddZoomOut(100) _
  +iAddColor(1) _
  +iAddFCircle(0,0,30) _
  +iAddZoomIn(100) _
  +iAddColor(1) _
  +iAddFBox(-18,-10,18,30) _
  +iAddColor(&H202060) _
  +iAddLine(-15,-55,-15,-15) _
  +iAddLine(15,-55,15,-15) _
  +iAddLine(-15,35,-15,55) _
  +iAddLine(15,35,15,55) _
  +iAddZoomIn(60) _
  +iAddZoomIn(40) _
  +iAddColor(&H303030) _
  +iAddFCircle(-15,-68,3) _
  +iAddFCircle(15,-68,3) _
  +iAddFCircle(-15,68,3) _
  +iAddFCircle(15,68,3)
  
i+=1
w.model(i)=new TModel
w.model(i)->mName="Blue Train"
w.model(i)->mBuild= _
   iVehicle _
  +iAddZoomOut(200) _
  +iAddColor(1) _
  +iAddLine(-20,-70,20,70) _
  +iAddLine(20,-70,-20,70) _
  +iAddZoomIn(200) _
  +iAddColor(&H4040e0) _
  +iAddFBox(-20,-68,20,68) _
  +iAddZoomOut(100) _
  +iAddColor(1) _
  +iAddFCircle(0,0,30) _
  +iAddZoomIn(100) _
  +iAddColor(1) _
  +iAddFCircle(0,0,15) _
  +iAddColor(&H2020e0) _
  +iAddLine(-20,-50,0,-55) _
  +iAddLine(0,-55,20,-50) _
  +iAddColor(&H202060) _
  +iAddLine(-15,-40,-15,40) _
  +iAddLine(15,-40,15,40) _
  +iAddZoomIn(60) _
  +iAddColor(&H4040e0) _
  +iAddFTri(-20,-68,20,-68,0,-73) _
  +iAddFTri(-20,68,20,68,0,73) _
  +iAddZoomIn(40) _
  +iAddColor(&H303030) _
  +iAddFCircle(-15,-73,3) _
  +iAddFCircle(15,-73,3) _
  +iAddFCircle(-15,73,3) _
  +iAddFCircle(15,73,3)
  
i+=1
w.model(i)=new TModel
w.model(i)->mName="Brown Car"
w.model(i)->mBuild= _
   iVehicle _
  +iAddZoomOut(200) _
  +iAddColor(&H808040) _
  +iAddLine(-20,-70,20,70) _
  +iAddLine(20,-70,-20,70) _
  +iAddZoomIn(200) _
  +iAddColor(&H808040) _
  +iAddFBox(-20,-70,20,70) _
  +iAddZoomIn(100) _
  +iAddColor(&H202020) _
  +iAddBox(-15,-50,15,50) _
  +iAddZoomIn(40) _
  +iAddColor(&H303030) _
  +iAddFCircle(-15,-73,3) _
  +iAddFCircle(15,-73,3) _
  +iAddFCircle(-15,73,3) _
  +iAddFCircle(15,73,3)
  

Print "<<< 5 >>>"


'################################################
'## place items
'################################################


'House
i=0
i+=1:CreateItem(i,ofx+120*m,ofy+120*m,ofx+140*m,ofy+100*m, Buildings,&Hc00000,ScaleBuilding)
i+=1:CreateItem(i,ofx+280*m,ofy+280*m,ofx+300*m,ofy+300*m, Buildings,&Hc00000,ScaleBuilding)
i+=1:CreateItem(i,ofx+380*m,ofy+280*m,ofx+400*m,ofy+300*m, Buildings,&Hc00000,ScaleBuilding)

'Really big house
'i+=1:CreateItem(Items(i),ofx+300*m,2500*m,6000*m,3500*m,1,&Hc00000,building)

'Track 2
i+=1:CreateItem(i,ofx+300*m,ofy+130*m,ofx+375*m,ofy+130*m, Buildings+1,&Hc00000,ScaleBuilding)
'Track 3
i+=1:CreateItem(i,ofx+1000*m,ofy+200*m,ofx+1075*m,ofy+200*m, Buildings+1,&Hc00000,ScaleBuilding)
'Track 4
i+=1:CreateItem(i,ofx+1580*m,ofy+280*m,ofx+1630*m,ofy+230*m, Buildings+1,&Hc00000,ScaleBuilding)
'Track 5
i+=1:CreateItem(i,ofx+660*m,ofy+720*m,ofx+735*m,ofy+720*m, Buildings+1,&Hc00000,ScaleBuilding)
i+=1:CreateItem(i,ofx+790*m,ofy+420*m,ofx+865*m,ofy+420*m, Buildings+1,&Hc00000,ScaleBuilding)

'forest
i+=1:CreateItem(i,ofx+700*m,ofy+150*m,ofx+700*m,ofy+350*m, Vegetation,0,ScaleBuilding)
i+=1:CreateItem(i,ofx+1400*m,ofy+250*m,ofx+1400*m,ofy+400*m, Vegetation,0,ScaleBuilding)
i+=1:CreateItem(i,ofx+200*m,ofy+400*m,ofx+200*m,ofy+600*m, Vegetation,0,ScaleBuilding)
i+=1:CreateItem(i,ofx+650*m,ofy+450*m,ofx+650*m,ofy+650*m, Vegetation,0,ScaleBuilding)
i+=1:CreateItem(i,ofx+1700*m,ofy+600*m,ofx+1700*m,ofy+800*m, Vegetation,0,ScaleBuilding)
i+=1:CreateItem(i,ofx+800*m,ofy+800*m,ofx+800*m,ofy+1050*m, Vegetation,0,ScaleBuilding)

'set user controls to train 1 as default
g.ctrl=0
g.now=Timer
g.Frame=0
g.Fps=55


'################################################
'## Main (Loop)
'################################################


Print "<<< 6 >>>"

Color &H000080,&Ha0a0a0
Cls

Do
  
  
  '################################################
  '## Main (Train simulation)
  '################################################
  

  ' move train
  world_sim
  
  ScanCam+=1
  If ScanCam>=CScanCam Then
    ScanCam=0
  EndIf

  
  '################################################
  '## Main (Show frame or skip, if CPU is too slow)
  '################################################
  
  
  g.PrintFrame=0
  If (g.SkipFrame=0) Then g.PrintFrame=1
  If (g.SkipFrame=1) Then g.PrintFrame=1
  If (g.SkipFrame>1) Then
    If (g.Frame Mod g.SkipFrame)=0 Then g.PrintFrame=1
  EndIf
  
  
  '################################################
  '## Main (Draw Graphics) - end
  '################################################
  
  If g.PrintFrame Then
    
    'highlight window under mouse cursor
    If MouseWindow=1 Then
      Line(0,0)-(479,479),&Hffffff,B
    Else
      Line(0,0)-(479,479),&Ha0a0a0,B
    EndIf

    If MouseWindow=2 Then
      Line(480,0)-(639,159),&Hffffff,B
    Else
      Line(480,0)-(639,159),&Ha0a0a0,B
    EndIf

    If MouseWindow=3 Then
      Line(480,160)-(639,319),&Hffffff,B
    Else
      Line(480,160)-(639,319),&Ha0a0a0,B
    EndIf

    If MouseWindow=4 Then
      Line(480,320)-(639,479),&Hffffff,B
    Else
      Line(480,320)-(639,479),&Ha0a0a0,B
    EndIf

    'Display this frame
    
    'Main window
    world_render(win480, -1)
    
    'put window win480 later... after LoopEdit
    'Put(v.PosX,v.PosY),win480,PSet

    'Save current status in View1
    'Do that after "world_render" because auto-camera control
    'will change views Offsets
    View1=v
    
    'Right top window
    'Set View2 as active window
    v=View2
    world_render(win160, 4)
    Put(v.PosX,v.PosY),win160,PSet
    
    'Right mid window
    'Set View3 as active window
    v=View3
    world_render(win160, 4)
    Put(v.PosX,v.PosY),win160,PSet
    
    'Right bottom window
    'Displays a fix zoomed View1 center
    'Set View1 as active window
    v=View1
    'i,j= current center position
    i=SCX:j=SCY
    'Rescale window to 160*160 Pixel
    v.WinX=View2.WinX
    v.WinY=View2.WinY
    v.VisBorderX=View2.VisBorderX
    v.VisBorderY=View2.VisBorderY
    'Set new scale factor
    'v.Scale=v.Scale*0.5
    v.Scale=500
    'Center screen
    ScreenCenter(i,j)
    'Set window position to lower right
    v.PosX=480+1
    v.PosY=320+1
    'No debug display
    v.Debug=0
    'Render the view
    world_render(win160, 4)
    Put(v.PosX,v.PosY),win160,PSet
    
    'Set View1 as active window
    v=View1
        
  EndIf
  
  
  '################################################
  '## Main (Mouse control)
  '################################################
  
  
  g.Mousexs=g.Mousex
  g.Mouseys=g.Mousey
  g.Mousewhs=g.Mousewh
  g.Mousebts=g.Mousebt

  If g.Mousebt=0 Then g.Mousehold=0
  If g.Mousebt<>g.Mousebts Then g.Mousehold=0
  If (g.Mousebt<>0) And (g.Mousebt=g.Mousebts) Then g.Mousehold+=1

  GetMouse g.MouseX, g.MouseY, g.MouseWh, g.MouseBt
  
  If g.Mousex<0 Then
    g.Mousex=v.WinX/2
    g.Mousey=v.WinY/2
    g.Mousewh=g.Mousewhs
    g.Mousebt=0
  EndIf
  
  'check for window area under mouse cursor
  If g.Mousex>=1 AndAlso g.Mousex<v.WinX _
  AndAlso g.Mousey>=1 AndAlso g.Mousey<v.WinY Then
    MouseWindow=1
  ElseIf g.Mousex>481 AndAlso g.Mousex<639 _
  AndAlso g.Mousey>1 AndAlso g.Mousey<159 Then
    MouseWindow=2
  ElseIf g.Mousex>481 AndAlso g.Mousex<639 _
  AndAlso g.Mousey>161 AndAlso g.Mousey<319 Then
    MouseWindow=3
  ElseIf g.Mousex>481 AndAlso g.Mousex<639 _
  AndAlso g.Mousey>321 AndAlso g.Mousey<479 Then
    MouseWindow=4
  Else
    MouseWindow=0
  EndIf

'  'check for valid mouse coordinates
'  If g.Mousex<1 OrElse g.Mousex>=v.WinX _
'  OrElse g.Mousey<1 OrElse g.Mousey>v.WinY Then
'    g.MouseX=g.MouseXs
'    g.MouseY=g.MouseYs
'    g.MouseWhs=g.MouseWh 'forget change
''    g.MouseBt=0          'ignore button
'  EndIf
  
'  If g.Mousex>=1 AndAlso g.Mousex<v.WinX _
'  AndAlso g.Mousey>=1 AndAlso g.Mousey<v.WinY Then
'    MouseWindow=1
'  EndIf
  
  If MouseWindow=2 Then
    g.Mousex=g.Mousex-480
  EndIf
  
  
  
  'Select control by mouseclick
  If (MouseWindow=1) AndAlso (g.Mousebt=0) _
  AndAlso (g.Mousebts=1) AndAlso (g.Mousehold<=(g.Fps/click+g.SkipFrame)) Then
    'first try to switch something
    'switch turnout
    i=0
    j=0
    Do
      i+=1
      If w.Turnouts(i)<>0 Then
        If Abs(xcoor(w.Turnouts(i)->SwitchCoor.x)-g.Mousex) < (5+2*m/v.Scale) _
        And Abs(ycoor(w.Turnouts(i)->SwitchCoor.y)-g.Mousey) < (5+2*m/v.Scale) Then
          j=i
        EndIf
      EndIf
    Loop Until (i>=MaxTurnouts) ' fxm inspired patch - see http://www.freebasic.net/forum/viewtopic.php?p=160305#160305

    If j<>0 Then
      SwitchTurnout(w.Turnouts(j))
    EndIf
    
    'if switch was successful, then j<>0
    'if not, try to select something
    
    If j=0 Then
      'select train
      v.cam=0
      g.ctrl=0
      g.trksel=0
      g.ItemSel=0
      Do
        j+=1
        
        'select subtrack while editing a track
        If (g.EditTrkPtr<>0) And (g.EditTrkBasePtr<>0) Then
          Dim As PTrack SearchTrack
          SearchTrack=g.EditTrkBasePtr->start
          Do While (SearchTrack<>g.EditTrkBasePtr->last)
            If Abs(xcoor(SearchTrack->x)-g.Mousex) < (5+2*m/v.Scale) _
            And Abs(ycoor(SearchTrack->y)-g.Mousey) < (5+2*m/v.Scale) Then
              If SearchTrack<>0 Then g.EditTrkPtr=SearchTrack
            EndIf
            SearchTrack=SearchTrack->pn
          Loop
        EndIf
  
        'select track
        For i=1 To maxtracks
          If w.Start(i)<>0 Then
            If Abs(xcoor(w.Start(i)->x)-g.Mousex) < (5+4*m/v.Scale) _
            And Abs(ycoor(w.Start(i)->y)-g.Mousey) < (5+4*m/v.Scale) Then
              g.trksel=i
              'if track editor active, set pointers to new track
              If Left$(ks,3)=K_edittrackFlag Then
                g.EditTrk=g.trksel
                g.EditTrkBasePtr=w.Start(g.trksel)
                g.EditTrkPtr=g.EditTrkBasePtr->last
              EndIf
            EndIf
          EndIf
        Next
  
        If g.trksel<>0 Then Exit Do
        
        'select train
        For i=1 To maxtrains
          If w.Train(i)<>0 Then
            If Abs(xcoor(w.Train(i)->x)-g.Mousex) < (j+4*m/v.Scale) _
            And Abs(ycoor(w.Train(i)->y)-g.Mousey) < (j+4*m/v.Scale) Then
              g.ctrl=i
            EndIf
          EndIf
        Next
        
        If g.ctrl<>0 Then Exit Do
        
        'select item
        For i=1 To MaxItems
          If w.Items(i)<>0 Then 
              If Abs(xcoor(w.Items(i)->a.x)-g.Mousex) < (10+4*m/v.Scale) _
              And Abs(ycoor(w.Items(i)->a.y)-g.Mousey) < (10+4*m/v.Scale) Then
                g.ItemSel=i
              EndIf
          EndIf
        Next
        
        If g.ItemSel<>0 Then Exit Do
        
      Loop Until (j>50)
    EndIf
  EndIf


  'Drag map by mouse when holding mousebutton
  If (MouseWindow=1) AndAlso g.Mousehold>(g.Fps/click+g.SkipFrame) Then
    If g.Mousebt=1 Then
      If g.trksel<>0 Then
        'If distance between mouse and track is too big.
        'then unselect track
        If Abs(xcoor(w.Start(g.trksel)->x)-g.Mousex)<50 _
        and Abs(ycoor(w.Start(g.trksel)->y)-g.Mousey)<50 Then
          w.Start(g.trksel)->x=p2wx(g.Mousex)
          w.Start(g.trksel)->y=p2wy(g.Mousey)
          ActivateTrack(w.Start(g.trksel))
        Else
          g.trksel=0
        EndIf
      Else
        If g.ItemSel<>0 Then

          'remember if drag point a or b
          If g.Drag=0 Then
            'Move item point A
            If Abs(xcoor(w.Items(g.ItemSel)->a.x)-g.Mousex)<20 _
            And Abs(ycoor(w.Items(g.ItemSel)->a.y)-g.Mousey)<20 Then
              g.Drag=1
              'Move item point B
            ElseIf Abs(xcoor(w.Items(g.ItemSel)->b.x)-g.Mousex)<20 _
              And Abs(ycoor(w.Items(g.ItemSel)->b.y)-g.Mousey)<20 Then
              g.Drag=2
            EndIf
          EndIf
          
          'Move item point A
          If g.Drag=1 Then
            i=w.Items(g.ItemSel)->b.x-w.Items(g.ItemSel)->a.x
            j=w.Items(g.ItemSel)->b.y-w.Items(g.ItemSel)->a.y
            w.Items(g.ItemSel)->a.x=p2wx(g.Mousex)
            w.Items(g.ItemSel)->a.y=p2wy(g.Mousey)
            w.Items(g.ItemSel)->b.x=w.Items(g.ItemSel)->a.x+i
            w.Items(g.ItemSel)->b.y=w.Items(g.ItemSel)->a.y+j
            'Move item point B
          ElseIf g.Drag=2 Then
              w.Items(g.ItemSel)->b.x=p2wx(g.Mousex)
              w.Items(g.ItemSel)->b.y=p2wy(g.Mousey)
          EndIf

        Else
          v.Offx=v.Offx+g.Mousex-g.Mousexs
          v.Offy=v.Offy+g.Mousey-g.Mouseys
          v.cam=0
        EndIf
      EndIf
    Else
      g.Drag=0 'drag inactive
    EndIf
  EndIf


  'Drag map in window 2 by mouse when holding mousebutton
  If (MouseWindow=2) AndAlso g.Mousehold>(g.Fps/click+g.SkipFrame) Then
    If g.Mousebt=1 Then
      view2.Offx=view2.Offx+g.Mousex-g.Mousexs
      view2.Offy=view2.Offy+g.Mousey-g.Mouseys
    Else
      g.Drag=0 'drag inactive
    EndIf
  EndIf
  
  
'################################################
'## Main (Keyboard control)
'################################################
  
  'user control
  'ks=actual pressed key
  'if ks contains "(xyz)" then add actual key behind ")"
  'this allows different modes of operation
  'e.g. "(e)" for edit mode



  'check for stacked command (mor than one keypress)
  If ks=K_edittrackSignal Then
    'do not delete ks
  Else
    i=InStr(ks,")")
    If i Then
      ks=Left$(ks,i)
    Else
      ks=""
    EndIf
  EndIf

  ks=ks+InKey$

  If ks=Chr(255)+Chr(15) Then ks=ks+InKey$  'Detect Shift TAB
  
  If ks=k_help Then    'F1 Help
    'Cls
    Line win480,(0,0)-(v.WinX-1,v.WinY-1),&H106010,BF
    i=0
    GfxPrint6 "=================================================================",0,i,&Hffffff,win480:i=i+8
    GfxPrint6 "Train Simulator "+Version,0,i,&Hffffff,win480:i=i+8
    GfxPrint6 "=================================================================",0,i,&Hffffff,win480:i=i+8
    GfxPrint6 "Program:     (C) oog / proog.de 2011, License: GPL V3",0,i,&Hffffff,win480:i=i+8
    GfxPrint6 "Subs, Libs:  Fragmeister, FreeBASIC Forum",0,i,&Hffffff,win480:i=i+8
    GfxPrint6 "Maps:        (C) OpenStreetMap contributors, CC-BY-SA ",0,i,&Hffffff,win480:i=i+8
    GfxPrint6 "UK Maps:     Contains Ordnance Survey data",0,i,&Hffffff,win480:i=i+8
    GfxPrint6 "             (C) Crown copyright and database right 2010. ",0,i,&Hffffff,win480:i=i+8
    GfxPrint6 "",0,i,&Hffffff,win480:i=i+8
    GfxPrint6 "=================================================================",0,i,&Hffffff,win480:i=i+8
    GfxPrint6 "Navigation",0,i,&Hffffff,win480:i=i+8
    GfxPrint6 "=================================================================",0,i,&Hffffff,win480:i=i+8
    GfxPrint6 "Move map:    Cursor keys or Left Mouse-button+move mouse",0,i,&Hffffff,win480:i=i+8
    GfxPrint6 "Zoom:        Pg-up/down: zoom to center of the window",0,i,&Hffffff,win480:i=i+8
    GfxPrint6 "             Mouse-wheel: zoom to mousepointer",0,i,&Hffffff,win480:i=i+8
    GfxPrint6 "Watch train: w, camera follows active train",0,i,&Hffffff,win480:i=i+8
    GfxPrint6 "track:       t, center to track (no zoom adjust)",0,i,&Hffffff,win480:i=i+8
    GfxPrint6 "",0,i,&Hffffff,win480:i=i+8
    GfxPrint6 "=================================================================",0,i,&Hffffff,win480:i=i+8
    GfxPrint6 "Train control",0,i,&Hffffff,win480:i=i+8
    GfxPrint6 "=================================================================",0,i,&Hffffff,win480:i=i+8
    GfxPrint6 "Select:      Press 1..0, TAB, Shift+Tab, Click on locomotive",0,i,&Hffffff,win480:i=i+8
    GfxPrint6 "Speed:       ,+. for active train, ;+: for all trains",0,i,&Hffffff,win480:i=i+8
    GfxPrint6 "More speed:  k+l for active train, K+L for all trains",0,i,&Hffffff,win480:i=i+8
    GfxPrint6 "Turnout:     u U switch turnout in front / behind train",0,i,&Hffffff,win480:i=i+8
    GfxPrint6 "Autopilot:   a   stop train in next station",0,i,&Hffffff,win480:i=i+8
    GfxPrint6 "beam:        b,  beam train to other track",0,i,&Hffffff,win480:i=i+8
    GfxPrint6 "Stop:        s",0,i,&Hffffff,win480:i=i+8
    GfxPrint6 "Cancel stop: Space",0,i,&Hffffff,win480:i=i+8
    GfxPrint6 "",0,i,&Hffffff,win480:i=i+8
    GfxPrint6 "=================================================================",0,i,&Hffffff,win480:i=i+8
    GfxPrint6 "Track control",0,i,&Hffffff,win480:i=i+8
    GfxPrint6 "=================================================================",0,i,&Hffffff,win480:i=i+8
    GfxPrint6 "Select:      Click on track root (a circle)",0,i,&Hffffff,win480:i=i+8
    GfxPrint6 "Move:        First select a track, then hold mousbutton and move",0,i,&Hffffff,win480:i=i+8
    GfxPrint6 "             Use cursor keys to move the map while dragging a track",0,i,&Hffffff,win480:i=i+8
    GfxPrint6 "             Use Pg-up/down to zoom while dragging a track",0,i,&Hffffff,win480:i=i+8
    GfxPrint6 "Rotate:      <, >",0,i,&Hffffff,win480:i=i+8
    GfxPrint6 "Edit:        e",0,i,&Hffffff,win480:i=i+8
    GfxPrint6 "Input Name:  i",0,i,&Hffffff,win480:i=i+8
    GfxPrint6 "",0,i,&Hffffff,win480:i=i+8
    GfxPrint6 "=================================================================",0,i,&Hffffff,win480:i=i+8
    GfxPrint6 "Extras",0,i,&Hffffff,win480:i=i+8
    GfxPrint6 "=================================================================",0,i,&Hffffff,win480:i=i+8
    GfxPrint6 "Show grid:   g (on/off)",0,i,&Hffffff,win480:i=i+8
    GfxPrint6 "Show map:    m (on/off)",0,i,&Hffffff,win480:i=i+8
    GfxPrint6 "Debug info:  d (on/off)",0,i,&Hffffff,win480:i=i+8
    GfxPrint6 "",0,i,&Hffffff,win480:i=i+8
    GfxPrint6 "Quit:        ESC, Alt+F4",0,i,&Hffffff,win480:i=i+8
    GfxPrint6 "",0,i,&Hffffff,win480:i=i+8
    Put (0,0),win480,alpha,200
    Do: Sleep 10: Loop Until InKey$<>""
  EndIf


  If ks=k_helpdisp Then    'Help Manual on/off
    helpman=helpman+1
    If helpman=3 Then
      helpman=0
    EndIf
  EndIf


  If ks=k_ohd Then         'OHD on/off
    OhdFps=OhdFps+1
    If OhdFps=3 Then
      OhdFps=0
    EndIf
  EndIf


'  If ks=k_SelectNewItem Then
'    newitem=newitem+1
'    If newitem=EndItems Then 'run out of buildings and vegetation
'      newitem=Items
'    EndIf
'  EndIf
  
  
  '################################################
  '## Track editor
  '################################################
  
  
  '## Track editor (1):
  '## Functions that need a selected track
  
  If g.trksel<>0 Then
  
    'edit track
    If ks=k_edittrack Then
      ks=K_edittrackFlag
      If g.EditTrk=0 Then
        g.EditTrk=g.trksel
        g.EditTrkBasePtr=w.Start(g.trksel)
        g.EditTrkPtr=g.EditTrkBasePtr->last
      EndIf
      ActivateTrack(w.Start(g.trksel))
    EndIf
    
    'edit track (open track)
    If ks=K_edittrackOpen Then
      OpenTrack(w.Start(g.trksel))
      'ActivateTrack(w.Start(v.trksel))
    EndIf
    
    'edit track (close track)
    If ks=K_edittrackClose Then
      CloseTrack(w.Start(g.trksel))
      'ActivateTrack(w.Start(v.trksel))
    EndIf
  
  EndIf
  
  
  '## Track editor (2):
  '## Functions that need a valid v.EditTrkPtr
  
  If (g.EditTrkPtr<>0) Then
    
    'edit track, install/uninstall turnout
    If ks=K_edittrackInstallTurnout Then
      'first check, if turnout exist and must be removed
      If (g.EditTrkPtr->Turn<>0) Then
        'Cleanup
        'find the corresponding turnout slot
        i=0
        Do
          i+=1

       'fxm speedup trick (using OrElse)
        Loop Until  (w.Turnouts(i)->pr1=g.EditTrkPtr) _
             OrElse (w.Turnouts(i)->pr2=g.EditTrkPtr) _
             OrElse (i>MaxTurnouts)

        If i<>MaxTurnouts Then
          'Now i is the number of the slot
          message("Remove turnout "+Str$(i))
          RemoveTurnout(i)
        Else
          message("Error: could not locate turnout slot.")
        EndIf
        g.EditTrkPtrA=0
      EndIf
      'Check if pointer A and B point to tracks
      If (g.EditTrkPtrA<>0) Then
        'Check if tracks have a turnout
        If (g.EditTrkPtrA->Turn=0) And (g.EditTrkPtr->Turn=0) Then
          'Create a new turnout
          'find a free turnout slot
          i=0
          Do
            i+=1
          Loop Until (w.Turnouts(i)=0) OrElse (i>MaxTurnouts)
          If i<>MaxTurnouts Then
            'Now free turnout slot is i
            
            'check if tracks are parallel
            'angle ist an integer (0..511)
            Dim As Integer ang1, ang2
            
            ang1=Abs(g.EditTrkPtrA->angle - g.EditTrkPtr->angle) And 511
            If ang1<256 Then
              ang2=ang1
            Else
              ang2=512-ang1
            EndIf
            
            If ang2 <= MinAngle Then 'angle between tracks
              message("Create turnout "+Str$(i))
              w.Turnouts(i)=AddTurnout(g.EditTrkPtrA, g.EditTrkPtr)
              g.EditTrkPtrA=0
            Else
              message("Error: Tracks not parallel ("_
                     +str(g.EditTrkPtrA->angle)+" <> "_
                     +str(g.EditTrkPtr->angle)+") angle512="_
                     +str(ang2))
            EndIf
          EndIf
        EndIf
      EndIf
    EndIf
    
    'edit track (select next)
    If ks=k_edittrackNext Then
      If g.EditTrkPtr->pn<>0 Then
        g.EditTrkPtr=g.EditTrkPtr->pn
        ScreenCenter(g.EditTrkPtr->x,g.EditTrkPtr->y)
      Else
        g.EditTrkPtr=g.EditTrkPtr->mytrack->start
        ScreenCenter(g.EditTrkPtr->x,g.EditTrkPtr->y)
      EndIf
    EndIf
    
    'edit track (select previous)
    If ks=k_edittrackPrev Then
      If g.EditTrkPtr->pr<>0 Then
        If g.EditTrkPtr->pr->pn=g.EditTrkPtr Then
          g.EditTrkPtr=g.EditTrkPtr->pr
          ScreenCenter(g.EditTrkPtr->x,g.EditTrkPtr->y)
        Else
          g.EditTrkPtr=g.EditTrkPtr->mytrack->last
          ScreenCenter(g.EditTrkPtr->x,g.EditTrkPtr->y)
        EndIf
      Else
        g.EditTrkPtr=g.EditTrkPtr->mytrack->last
        ScreenCenter(g.EditTrkPtr->x,g.EditTrkPtr->y)
      EndIf
    EndIf
    
    'edit track (set track forward)
    If ks=K_edittrackForward Then
      If g.EditTrk<>0 Then
        g.EditTrkPtr->tname="f"+Mid$(g.EditTrkPtr->tname,2,1)
        ActivateTrack(w.Start(g.EditTrk))
      EndIf
    EndIf
    
    'edit track (set track station)
    If ks=K_edittrackStation Then
      If g.EditTrk<>0 Then
        g.EditTrkPtr->tname="s"+Mid$(g.EditTrkPtr->tname,2,1)
        ActivateTrack(w.Start(g.EditTrk))
      EndIf
    EndIf
    
    'edit track (set track left)
    If ks=K_edittrackLeft Then
      If g.EditTrk<>0 Then
        g.EditTrkPtr->tname="l"+Mid$(g.EditTrkPtr->tname,2,1)
        ActivateTrack(w.Start(g.EditTrk))
      EndIf
    EndIf
    
    'edit track (set track right)
    If ks=K_edittrackRight Then
      If g.EditTrk<>0 Then
        g.EditTrkPtr->tname="r"+Mid$(g.EditTrkPtr->tname,2,1)
        ActivateTrack(w.Start(g.EditTrk))
      EndIf
    EndIf
    
    'edit track (set track left)
    If ks=K_edittrackSharpLeft Then
      If g.EditTrk<>0 Then
        g.EditTrkPtr->tname="L"+Mid$(g.EditTrkPtr->tname,2,1)
        ActivateTrack(w.Start(g.EditTrk))
      EndIf
    EndIf
    
    'edit track (set track right)
    If ks=K_edittrackSharpRight Then
      If g.EditTrk<>0 Then
        g.EditTrkPtr->tname="R"+Mid$(g.EditTrkPtr->tname,2,1)
        ActivateTrack(w.Start(g.EditTrk))
      EndIf
    EndIf
    
    'edit track (set track end segment)
    If ks=K_edittrackEndtrack Then
      If g.EditTrk<>0 Then
        g.EditTrkPtr->tname="e"
        ActivateTrack(w.Start(g.EditTrk))
      EndIf
    EndIf
    
    'edit track (insert new track)
    If ks=K_edittrackInsert Then
      If g.EditTrk<>0 Then
        If g.EditTrkPtr->tname="e" Then
          g.EditTrkPtr->tname="f"
        Else
          AddTrack(w.Start(g.EditTrk),"f")
        EndIf
        If g.EditTrkPtr->pn<>0 Then g.EditTrkPtr=g.EditTrkPtr->pn
        ScreenCenter(g.EditTrkPtr->x,g.EditTrkPtr->y)
        ActivateTrack(w.Start(g.EditTrk))
      EndIf
    EndIf
    
    'edit track (delete track)
    If ks=K_edittrackDelete Then
      If g.EditTrk<>0 Then
        If (g.EditTrkPtr->pr<>0) And (g.EditTrkPtr->pr<>0) _
        And (g.EditTrkPtr->mytrack->start<>g.EditTrkPtr) _
        And (g.EditTrkPtr->mytrack->last<>g.EditTrkPtr) _
        Then
          g.EditTrkPtr->pr->pn=g.EditTrkPtr->pn
          g.EditTrkPtr->pr->pf=g.EditTrkPtr->pf
          g.EditTrkPtr->pf->pr=g.EditTrkPtr->pr
          g.EditTrkPtrA=g.EditTrkPtr
          g.EditTrkPtr=g.EditTrkPtr->pf
          
          'replace "Allocate" by "New" and "DeAllocate" by "Delete" (hint from fxm / FreeBASIC forum)
          'DeAllocate g.EditTrkPtrA
          Delete g.EditTrkPtrA
          
          g.EditTrkPtrA=0
        EndIf
        ScreenCenter(g.EditTrkPtr->x,g.EditTrkPtr->y)
        ActivateTrack(w.Start(g.EditTrk))
      EndIf
    EndIf
    
    'edit track (set length)
    If (Left$(ks,3)=K_edittrackFlag) _
    AndAlso Len(ks)=4 _
    AndAlso (InStr("1234567890",Right$(ks,1))>0) Then
      If g.EditTrk<>0 Then
        g.EditTrkPtr->tname=Left$(g.EditTrkPtr->tname,1)+Right$(ks,1)
        ActivateTrack(w.Start(g.EditTrk))
      EndIf
    EndIf
    
    'edit track (set default length)
    If (ks=K_edittrackDefaultlength) Then
      If g.EditTrk<>0 Then
        g.EditTrkPtr->tname=Left$(g.EditTrkPtr->tname,1)
        ActivateTrack(w.Start(g.EditTrk))
      EndIf
    EndIf
    
  EndIf
  
  '## Track editor (3):
  '## Other Functions
  
  'edit track, set/reset vector TrackA
  If ks=K_edittrackSelect Then
    If g.EditTrkPtrA=g.EditTrkPtr Then
      g.EditTrkPtrA=0
    Else
      g.EditTrkPtrA=g.EditTrkPtr
    EndIf
  EndIf
  
  
  'edit track signal f/r
  If ks=K_EditTrackSignal Then
    ks=K_EditTrackFlag
    g.EditTrkPtr->SigF=lcase(InputBox("(1) Input Fwd Signal",g.EditTrkPtr->SigF))
    g.EditTrkPtr->SigR=lcase(InputBox("(2) Input Rev Signal",g.EditTrkPtr->SigR))
  EndIf
  
  
  'edit track (end)
  If ks=k_edittrackEnd Then
    ks=""
    If g.EditTrk<>0 Then
      ActivateTrack(w.Start(g.EditTrk))
      g.EditTrkPtr=0
      g.EditTrk=0
    EndIf
    g.trksel=0
  EndIf
  
  
  '################################################
  '## Track editor end
  '################################################
  
  
  'switch turnout from selected train
  If g.ctrl<>0 Then
    
    'switch turnout in forward direction
    'search for turnout up to 100 track segments
    If (ks=K_SwitchTurnout) And (w.Train(g.ctrl)->sp>=0) _
    Or (ks=K_SwitchTurnoutReverse) And (w.Train(g.ctrl)->sp<0) Then
      i=0
      g.EditTrkPtr=w.Train(g.ctrl)->tr
      Do
        i+=1
        If g.EditTrkPtr->turn<>0 Then
          SwitchTurnout(g.EditTrkPtr->turn)
          Exit Do
        EndIf
        g.EditTrkPtr=g.EditTrkPtr->pf
      Loop Until (i>100) Or (g.EditTrkPtr=0)
      g.EditTrkPtr=0
    EndIf
    
    'switch turnout in reverse direction
    'search for turnout up to 100 track segments
    If (ks=K_SwitchTurnout) And (w.Train(g.ctrl)->sp<0) _
    Or (ks=K_SwitchTurnoutReverse) And (w.Train(g.ctrl)->sp>=0) Then
      i=0
      g.EditTrkPtr=w.Train(g.ctrl)->tr
      Do
        i+=1
        If g.EditTrkPtr->turn<>0 Then
          SwitchTurnout(g.EditTrkPtr->turn)
          Exit Do
        EndIf
        g.EditTrkPtr=g.EditTrkPtr->pr
      Loop Until (i>100) Or (g.EditTrkPtr=0)
      g.EditTrkPtr=0
    EndIf
    
  EndIf
  
  
  ' add new item
  If (ks=K_NewItem) Then
    If g.trksel<>0 _
    AndAlso "y"=YesOrNoBox("Place a new Train?") Then
      'Add train to track
      NewTrain(g.trksel, 20*5, Locomotives+g.trksel Mod 2, g.trksel)
      
    Else
      If (MouseWindow=1) AndAlso g.ItemSel=0 _
      AndAlso "y"=YesOrNoBox("Place new Item at Mouse Pointer?") Then
        'Add station building
        i=1
        Do While (w.Items(i)<>0)
          i+=1
        Loop
        If i<MaxItems Then
          
          'replace "Allocate" by "New" and "DeAllocate" by "Delete" (hint from fxm / FreeBASIC forum)
          'w.Items(i)=CAllocate(SizeOf(TItem))
          w.Items(i)=New TItem
          
          'j=1 'house
          'j=2 'station building
          'newitem
          
          CreateItem(i,p2wx(g.Mousex),p2wy(g.Mousey), _
            p2wx(g.Mousex)+50*m,p2wy(g.Mousey),buildings,&Hc00000,ScaleBuilding)
          
          message("New item "+Str$(i))
        EndIf
      Else
        'Exchange item
      EndIf
    EndIf
  EndIf
  
  
  ' Plus: add waggon / next item
  If ks=K_Plus Then
    If g.ctrl<>0 Then
      If w.Train(g.ctrl)->Waggons<100 Then w.Train(g.ctrl)->Waggons+=1
    EndIf
    If g.ItemSel<>0 Then
      w.Items(g.ItemSel)->build+=1
      If w.Items(g.ItemSel)->build>EndItems Then
        w.Items(g.ItemSel)->build=Items
      EndIf
    EndIf
  EndIf
  
  
  ' Minus: delete waggon / previous item
  If ks=K_Minus Then
    If g.ctrl<>0 Then
      If w.Train(g.ctrl)->Waggons>0 Then w.Train(g.ctrl)->Waggons-=1
    EndIf
    If g.ItemSel<>0 Then
      w.Items(g.ItemSel)->build-=1
      If w.Items(g.ItemSel)->build<Items Then
        w.Items(g.ItemSel)->build=EndItems
      EndIf
    EndIf
  EndIf
  
  ' delete item
  If ks=K_Delete Then
    If g.ctrl<>0 _
    AndAlso "y"=YesOrNoBox("Delete selected train?") Then
      'Delete Train
      LogFile("")
      LogFile("Delete a Train")
      DeleteTrain(g.ctrl)
      
    ElseIf g.ItemSel<>0 _
    AndAlso "y"=YesOrNoBox("Delete selected Item?") Then
      'Delete Item
      LogFile("")
      LogFile("Delete an Item")
      DeleteItem(g.ItemSel)

    ElseIf g.trksel<>0 _
    AndAlso "y"=YesOrNoBox("Delete Track and Trains on Track?") Then
      'Delete track
      LogFile("")
      LogFile("Delete a Track")
      DeleteTrack(g.trksel)
    
    ElseIf "y"=YesOrNoBox("Cleanup the World?") Then
      'Delete everything in the world
      LogFile("")
      LogFile("Cleanup the World")
      
'      'delete all models
'      For i=0 To MaxModels
'        Delete(w.Model(i))
'       w.Model(i)=0
'      Next i
      
      'delete all items
      For i=0 To MaxItems
        If w.Items(i)<>NULL Then InfoBox("Delete Item "+str(i))
        DeleteItem(i)
      Next i
      LogFile("  all items deleted")

      'delete all trains
      For i=1 To MaxTrains
        If w.Train(i)<>NULL Then InfoBox("Delete Train "+str(i))
        DeleteTrain(i)
      Next i
      LogFile("  all trains deleted")

      'delete all turnouts
      For i=1 To MaxTurnouts
        If w.Turnouts(i)<>NULL Then InfoBox("Delete Turnout "+str(i))
        RemoveTurnout(i)
      Next i
      LogFile("  all turnouts deleted")
      
      'delete all tracks
      For i=0 to MaxTracks
        If w.Start(i)<>NULL Then InfoBox("Delete Track "+str(i))
        DeleteTrack(i)
      Next i
      
      LogFile("Cleanup the World - done.")
      
    EndIf
  EndIf
  
  ' insert new track
  If (MouseWindow=1) AndAlso (ks=K_Insert) _
  AndAlso "y"=YesOrNoBox("Place new Track at Mouse Pointer?")Then
    LogFile("")
    LogFile("Create a New Track")
    i=0
    Do
      i+=1
    Loop Until (w.Start(i)=0) Or (i>MaxTracks)
    If i<=MaxTracks Then
      w.Start(i)=NewTrack("Track "+Str$(i), _
        p2wx(g.Mousex), p2wy(g.Mousey), 0, 0)
      AddTrack(w.Start(i),"e")
      AddTrack(w.Start(i),"f")
      AddTrack(w.Start(i),"e")
      CloseTrack(w.Start(i))
      ActivateTrack(w.Start(i))
      OpenTrack(w.Start(i))
    EndIf
  EndIf
  
  'rotate track
  If (ks=k_rotateleft) Or (ks=k_rotateright) Then
    If g.trksel<>0 Then
      'rotate
      w.Start(g.trksel)->angle=w.Start(g.trksel)->angle+IIF(ks=k_rotateleft, MinAngle, -MinAngle)

      'avoid negative angles
      Do While w.Start(g.trksel)->angle<0
        w.Start(g.trksel)->angle+=512
      Loop

      'avoid angles >511
      w.Start(g.trksel)->angle=w.Start(g.trksel)->angle And 511

      ActivateTrack(w.Start(g.trksel))
    EndIf
  EndIf
  
  
  'Switch grid on/off (performance)
  If ks=K_grid Then v.gridon=(v.gridon=0)

  'Switch map on/off (performance)
  If ks=K_map Then v.mapactive=(v.mapactive=0)

  'Switch landmap on/off (performance)
  If ks=K_landmap Then v.landmapactive=(v.landmapactive=0)

  'Switch debug on/off
  If ks=K_debug Then v.Debug=(v.Debug=0)
  
  
  'Zoom in
  'Zoom to center of screen
  If Left$(ks,3)<>K_LoopEditFlag Then
    If Right$(ks,2)=k_zoomin Then    'PG up
      If v.Scale>ZoomMinLevel Then
        i=SCX
        j=SCY
        v.Scale=v.Scale*9/10
        ScreenCenter(i,j)
      EndIf
    EndIf
  EndIf
  
  'Zoom out
  'Zoom to center of screen
  If Left$(ks,3)<>K_LoopEditFlag Then
    If Right$(ks,2)=k_zoomout Then  'PG down
      If v.Scale<ZoomMaxLevel Then
        i=SCX
        j=SCY
        v.Scale=v.Scale*10/9
        ScreenCenter(i,j)
      EndIf
    EndIf
  EndIf
  
  'Do only if mouse pointer is in window 1
  If (MouseWindow=1) Then
    'Zoom in
    'Zoom to mouse pointer
    If g.Mousewh-g.Mousewhs>0 Then 'Mouse wheel up
      If v.Scale>ZoomMinLevel Then
        i=p2wx(g.MouseX)
        j=p2wy(g.MouseY)
        v.Scale=v.Scale*9/10
        v.Offx=g.MouseX-i/v.Scale
        v.Offy=g.MouseY-j/v.Scale
      EndIf
    EndIf
    
    'Zoom out
    'Zoom to mouse pointer
    If g.Mousewh-g.Mousewhs<0 Then  'Mouse wheel down
      If v.Scale<ZoomMaxLevel Then
        i=p2wx(g.MouseX)
        j=p2wy(g.MouseY)
        v.Scale=v.Scale*10/9
        v.Offx=g.MouseX-i/v.Scale
        v.Offy=g.MouseY-j/v.Scale
      EndIf
    EndIf
  EndIf
  
  
  'Do only if mouse pointer is in window 2
  If (MouseWindow=2) Then
    'Zoom in
    'Zoom to mouse pointer
    If g.Mousewh-g.Mousewhs>0 Then 'Mouse wheel up
      If view2.Scale>ZoomMinLevel Then
        i=p2wxw2(g.MouseX)
        j=p2wyw2(g.MouseY)
        view2.Scale=view2.Scale*9/10
        view2.Offx=g.MouseX-i/view2.Scale
        view2.Offy=g.MouseY-j/view2.Scale
      EndIf
    EndIf
    
    'Zoom out
    'Zoom to mouse pointer
    If g.Mousewh-g.Mousewhs<0 Then  'Mouse wheel down
      If view2.Scale<ZoomMaxLevel Then
        i=p2wxw2(g.MouseX)
        j=p2wyw2(g.MouseY)
        view2.Scale=view2.Scale*10/9
        view2.Offx=g.MouseX-i/view2.Scale
        view2.Offy=g.MouseY-j/view2.Scale
      EndIf
    EndIf
  EndIf
  
  
  'save data file
  If ks=K_file _
  AndAlso "y"=YesOrNoBox("Save File?") Then
'    message("Save Data and Model File...")
    SaveDataFile
    SaveModelFile
  EndIf


  'load data file
  If ks=K_loadfile _
  AndAlso "y"=YesOrNoBox("Appand Tracks to existing Map?") Then
'    message("Load Data and Model File...")
    LoadDataFile(CDataFile)
    LoadModelFile(CModelFile)
    ks=""
  EndIf
  
  
  'Select camera
  If InStr(K_SelectCamera,ks) Then
    i=InStr(K_SelectCamera,ks)
    If w.Train(i)<>0 Then
      
      If CScanCamActive=0 AndAlso v.cam<>0 Then
        View3.cam=v.cam   'set view 3 to last viewed train
      EndIf
      
      'camera animation setup
      v.OldCamX=p2wx(v.WinX/2)
      v.OldCamY=p2wy(v.WinY/2)
      
      v.CamSlide=CCamSteps
      v.OldCamScale=v.Scale
      
      
      v.cam=i
      g.ctrl=v.cam
    EndIf
  EndIf
  
  'Select control by TAB
  If ks=K_CtrlNext Then  'TAB
    Do
      g.ctrl=g.ctrl+1
      If g.ctrl>maxtrains Then g.ctrl=1
    Loop Until w.Train(g.ctrl)<>0
  EndIf
  If ks=K_CtrlPrev Then 'Shift+TAB
    Do
      g.ctrl-=1
      If g.ctrl=0 Then g.ctrl=maxtrains
    Loop Until w.Train(g.ctrl)<>0
  EndIf
  
  'watch train
  'camera follows controlled train
  If (ks=K_WatchTrain) Andalso w.Train(g.ctrl)<>0 andalso (g.ctrl>0) Then
    If CScanCamActive=0 AndAlso v.cam<>0 Then
      View3.cam=v.cam   'set view 3 to last viewed train
    EndIf

      'camera animation setup
      v.OldCamX=p2wx(v.WinX/2)
      v.OldCamY=p2wy(v.WinY/2)
      
      v.CamSlide=CCamSteps
      v.OldCamScale=v.Scale

    v.cam=g.ctrl
  EndIf
  
  'scan camera - watch train
  If CScanCamActive=1 andalso ScanCam=0 Then
    Do
      View3.cam+=1
      If View3.cam>maxtrains Then View3.cam=1
    Loop Until (w.Train(View3.cam)<>0) _
    OrElse (View3.cam=1)        'avoid endless loop, when no trains exist
  EndIf
  
  
  'Center camera to track
  If (ks=K_CenterTrack) And (g.ctrl>0) Then
    'Center to train
    ScreenCenter(((w.Train(g.ctrl)->tr->mytrack->dimension.minx _
        +w.Train(g.ctrl)->tr->mytrack->dimension.maxx)/2), _
        ((w.Train(g.ctrl)->tr->mytrack->dimension.miny _
        +w.Train(g.ctrl)->tr->mytrack->dimension.maxy)/2))
    v.cam=0
  EndIf
  
  'Train auto pilot switch (stop at next station)
  If ks=K_TrainAutopilot And (g.ctrl>0) Then
    w.Train(g.ctrl)->control=w.Train(g.ctrl)->control Xor auto
  EndIf
  
  'Brake (stop train)
  If ks=K_Stop And (g.ctrl>0) Then
    w.Train(g.ctrl)->control=w.Train(g.ctrl)->control Xor brake
  EndIf
  
  'Beam train to other track
  If (ks=K_BeamTrack) And (g.ctrl>0) Then
  
    ' use global variable beamer for beaming to next track
    Do
     beamer+=1
     If beamer>MaxTracks Then beamer=0
    Loop Until w.Start(beamer)<>0
    w.Train(g.ctrl)->tr->mytrack=w.Start(beamer)
    w.Train(g.ctrl)->tr=w.Train(g.ctrl)->tr->mytrack->start

'    ' beaming to random track
'    w.Train(g.ctrl)->tr->mytrack=w.Start(1+Rnd*9)
'    w.Train(g.ctrl)->tr=w.Train(g.ctrl)->tr->mytrack->start
  EndIf
  
  'Control speed of selected train
  If (ks=K_AccRev) And (g.ctrl>0) Then w.Train(g.ctrl)->sp=w.Train(g.ctrl)->sp-1
  If (ks=K_AccFwd) And (g.ctrl>0) Then w.Train(g.ctrl)->sp=w.Train(g.ctrl)->sp+1
  If (ks=K_AccRevMore) And (g.ctrl>0) Then w.Train(g.ctrl)->sp=w.Train(g.ctrl)->sp-10
  If (ks=K_AccFwdMore) And (g.ctrl>0) Then w.Train(g.ctrl)->sp=w.Train(g.ctrl)->sp+10
  
  'Control speed of all train s
  If ks=K_AccAllRev Then: For i=1 To maxtrains: If w.Train(i)<>0 Then: w.Train(i)->sp=w.Train(i)->sp-1: EndIf: Next: EndIf
  If ks=K_AccAllFwd Then: For i=1 To maxtrains: If w.Train(i)<>0 Then: w.Train(i)->sp=w.Train(i)->sp+1: EndIf: Next: EndIf
  If ks=K_AccAllRevMore Then: For i=1 To maxtrains: If w.Train(i)<>0 Then: w.Train(i)->sp=w.Train(i)->sp-10: EndIf: Next: EndIf
  If ks=K_AccAllFwdMore Then: For i=1 To maxtrains: If w.Train(i)<>0 Then: w.Train(i)->sp=w.Train(i)->sp+10: EndIf: Next: EndIf
  
  'Move camera
  If Left$(ks,3)<>K_LoopEditFlag Then
    If Right$(ks,2)=K_CamUp Then: v.Offy=v.Offy+v.winx/30: v.cam=0: endif 'up
    If Right$(ks,2)=K_CamDn Then: v.Offy=v.Offy-v.winx/30: v.cam=0: endif 'down
    If Right$(ks,2)=K_CamLt Then: v.Offx=v.Offx+v.winy/30: v.cam=0: endif 'left
    If Right$(ks,2)=K_CamRt Then: v.Offx=v.Offx-v.winy/30: v.cam=0: endif 'right
  EndIf
  
'  'test loop editor
'  Dim As String edits
  
  If (ks=K_LoopEditStart) Then
    ks=K_LoopEditFlag
    If g.trksel=0 Then
      setloopedit("LoopEdit test:",@edits,100,100,20,&Hc0ffc0,&H206020,win480)
    Else
      setloopedit("Track Name:",@w.Start(g.trksel)->tname,100,100,20,&Hc0ffc0,&H206020,win480)
    EndIf
  EndIf
  loopedit(ks)
  If (Left$(ks,3)=K_LoopEditFlag) and loopedit_ready Then ks=""
  
  
  If g.PrintFrame Then
    'Main window
    Put(v.PosX,v.PosY),win480,PSet
  EndIf
  

  '################################################
  '## FPS count and adjust
  '################################################
  

  g.Frame+=1

  'FPS counter, reset every 2 seconds
  If (Timer-g.now)>2 Then
  
    g.Fps=g.Fps0
    g.Frame=0
    g.now=Timer

    If g.FpsLow Then g.SkipFrame+=1
    g.FpsLow=0
  EndIf
  g.Fps0=g.Frame/(Timer-g.now)


  'average time of last ten frames
  If (Timer-g.LastTime)<2 Then
    g.ThisTime=Timer-g.LastTime
    g.AvgTime = (g.AvgTime*30+g.ThisTime)/31
    If g.SkipFrame<>0 AndAlso g.AvgTime>g.AvgMax Then
      g.AvgMax=(g.AvgMax*10+g.AvgTime)/11
    EndIf
  EndIf
  g.LastTime=Timer


  If g.Fps<30 Then g.FpsLow=1

  If (g.Fps>60) And (g.SkipFrame>1) Then
    g.SkipFrame-=1
    g.Fps=45
'    g.AvgTime=0
'    g.AvgMax=0
  EndIf
  If (g.Fps>65) And (g.SkipFrame>0) Then
    g.SkipFrame=0
    g.Fps=45
'    g.AvgTime=0
'    g.AvgMax=0
  EndIf

  
  If (g.SkipFrame=0) Then Sleep 10  '20
  If (g.SkipFrame=1) Then Sleep 5  '10
  If (g.SkipFrame=2) Then Sleep 2   '1
  If (g.SkipFrame>2) Then Sleep 1   '1


'  'try to waste some time
'  If (Timer-g.LastTime)<2 Then
'    While (Timer-g.LastTime)*100 < g.AvgTime*120
'      Sleep 1
'    Wend
'  EndIf

'If (g.SkipFrame<1) Then
'  If g.ThisTime<g.AvgMax Then
'    Sleep (g.AvgMax-g.ThisTime)*500
'  EndIf
'EndIf


  If Right$(ks,2)=K_Quit2 Then ks=K_Quit 'Close window by ALT+F4

  'SCREENSYNC
  
Loop Until Right$(ks,1)=K_Quit

imagedestroy win480
imagedestroy win160

End


'BESETTINGS (don't change!):
'BECURSOR=18F0D
'BETOGGLE=1111111111111111111111111111111111111111111111111111111111111111111111111
'BETARGET=1